/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

(function($) {

    $(document).ready(function() {

        $('.ppftabs').each(function() {
            ppfadmin.activateTabs(this);
        });

        $('input[name="cid[]"]').change(function() {
            ppfadmin.toolbartoggle();
        });
        ppfadmin.toolbartoggle();

        $('a.js_sort_dir').click(function() {
            ppfadmin.filterdir(this);
        });

        $('.js_sort_list').change(function() {
            ppfadmin.filterlist(this);
        });
        
        ppfadmin.filled();
        
        var radioyesno = function() {
            $('.radioyesno').each(function() {
                if (this.checked) $(this).parent().addClass('checked');
                else $(this).parent().removeClass('checked');
            });
        }
        radioyesno();

        $('.radioyesno').change(function() {
            radioyesno();
        });



        // joomla 4 menu
        $('#sidebarmenu .item-level-3 a').each(function() {
            if (this.href.indexOf('com_ppf3') + 1) {
                $(this).addClass('ppfmenuitem');

                if (this.href.indexOf('projects') + 1) {
                    $(this).addClass('ppfprojects');
                }
                else if (this.href.indexOf('historys') + 1) {
                    $(this).addClass('ppfhistorys');
                }
                else if (this.href.indexOf('settings') + 1) {
                    $(this).addClass('ppfsettings');
                }
                else if (this.href.indexOf('shop') + 1) {
                    $(this).addClass('ppfshop');
                }
                else if (this.href.indexOf('attachment') + 1) {
                    $(this).addClass('ppfattachment');
                }
            }
        });

    });


    return ppfadmin = {
        filled: function() {
            let els = $('.ppf3_filter input').add('.ppf3_filter select');
            let fill = function() {
                els.each(function(){
                    if($(this).val()) $(this).addClass('filled');
                    else $(this).removeClass('filled');
                });
            }
            els.on('change', function(){
                fill();
            });
            fill();
        },

        toolbartoggle: function() {
            var btns = $('.activate, .deactivate, .delete', $('.ppf3_toolbar'));
            $('input[name="cid[]"]:checked').length ? btns.removeClass('ppfdisabled') : btns.addClass('ppfdisabled');
            this.categoriesCheck();
        },
        
        categoriesCheck: function() {
          var count = function(cid) {
            return $(cid).closest('tr').find('.ppftitle a').text().split('—').length - 1;
          }
          var level=0, cids = $('.cattable td input[name="cid[]"]');
          var btn = $('.delete', $('.ppf3_toolbar'));

          if(cids.length) {
            cids.each(function(i){
              if(this.checked) {
                if(! level || count(this) <= level) level = count(this);
              }
              else {
                if(level && count(this) > level){
                  btn.addClass('ppfdisabled');
                  return;
                }
                else level = 0;
              }
            });
          }
        },
        
        inner:function(el) {
          var text = $(el).text();
          var id = $('input[name="ppffield[id]"]').val();
          if(id && text.indexOf('{0}') > 0) text = text.replace('{0}', id);
          else text = text.replace('{0}', '0');
          $(el).closest('.ppffieldbody').find('textarea,input').val(text);
        },
        
        filterdir: function(el) {
            var col = $(el).data('order').split('.');
            var form = document.forms.ppfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterdir">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            form.submit();
        },

        filtersearch: function() {
            var col = $('input.search').data('order').split('.');
            var form = document.forms.ppfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterlist">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            $('<input type="hidden" name="v" value="">').appendTo(form).val($('input.search').val());
            form.submit();
        },
        
        filtertext: function(inp) {
            var col = $(inp).data('order').split('.');
            var form = document.forms.ppfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterlist">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            $('<input type="hidden" name="v" value="">').appendTo(form).val($(inp).val());
            form.submit();
        },

        filterlist: function(el) {
            var col = $(el).data('order').split('.');
            var val = $(el).val();
            var form = document.forms.ppfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterlist">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            $('<input type="hidden" name="v" value="'+val+'">').appendTo(form);
            form.submit();
        },

        ppflistedit: function(task) {
            var form = document.forms.ppfadminform;
            if (task.split('.')[1] == 'close') {
              $('<input type="hidden" name="task" value="'+task+'">').appendTo(form);
              return form.submit();
            }
            
            var fl, submt = $('input[type="submit"]', form);
            if(! submt.length) submt = $('<input type="submit">').appendTo(form);
            
            $('input, select, textarea', form).each(function() {
                if(this.hasAttribute('required') && ! this.checkValidity()) {
                  var tab = this.closest('.ppftabsitem');
                  var parentTabs = $(this).closest('.ppftabs').find('.ppftabsitem');
                  parentTabs.each(function(i) {
                    if(this == tab) $('.ppftabsitemlabel')[i].click();
                  });
                  fl = 1;
                  submt.click();
                  return;
                }
            });
            if(fl) return false;

            $('<input type="hidden" name="task" value="'+task+'">').appendTo(form);
            submt.click();
        },

        help: function(task) {
            $.ajax({
                url: "index.php?option=com_ppf3&task="+task,
                success: function(msg) {
                    $('.helpbox').remove();
                    $('<div class="helpbox"><div class="ppfmessboxclose" onclick="this.parentNode.parentNode.removeChild(this.parentNode)">✕</div>'+msg+'</div>').insertBefore(document.forms.ppfadminform);
                }
            });
        },

        activateTabs: function(e) {
            var items = $(e).children('.ppftabsitem');

            items.each(function(i) {
                $(this).hide(0);
            });
            items[0].style.display = 'block';

            var labels = $('.ppftabsitemlabel', $(e).children('.ppftabslabelsbox'));
            labels.on('click', function() {
                labels.removeClass('ppftabactiv');
                $(this).addClass('ppftabactiv');
                items.css('display', 'none');
                for (var i = 0; i < labels.length; i++) {
                    if (labels[i] == this) items[i].style.display = 'block';
                }
            });

        },


        checkAll: function(checkbox, stub) {
            if (!checkbox.form) {
                return false;
            }

            var currentStab = stub || 'cb';
            var elements = [].slice.call(checkbox.form.elements);
            elements.forEach(function(element) {
                if (element.type === checkbox.type && element.name === 'cid[]') {
                    element.checked = checkbox.checked;
                }
            });

            return true;
        },
        
        plasma: function(btn) {
          var upcod, data, valid, email = btn.form.ppemail.value, host = btn.form.pphost.value;
          if(email) {
            var re = /\S+@\S+\.\S+/;
            if(re.test(email)) {
              valid = email;
            }
          }
          if(! valid) $(btn.form.ppemail).css('border-color', 'red').animate({'opacity': 0},600, function(){
            $(btn.form.ppemail).css('border-color', '#ccc').animate({'opacity': 1},600)
          });
          else {
            upcod = $('select[name="ppffield[upcod]"]', btn.form).val();
            data = this.b64EncodeUnicode(upcod+'*'+valid+'*'+host);
            let action = '//plasma-web.ru/index.php?option=com_ppf3&task=btns&id=20&data='+data;
            window.location.href = action;
          }
        },
        
        b64EncodeUnicode: function(str) {
            return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, function(match, p1) {
                return String.fromCharCode('0x' + p1);
            }));
        },


    }
})(jQuery);
