<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class controller extends ppf_admin
{
    protected $model;

    public function __construct()
    {
        $this->task = ppf::gettask();

        if ($this->task) {
            $this->execute();
        }

        $this->display();
    }

    public function display()
    {
        $view = $this->task ? explode('.', $this->task)[0] : ppf::gettask('view', 'projects');
        $viewpath = PPF3_ADMIN_DIR . 'src/view/' . $view . '.php';

        if (is_file($viewpath)) {
            Text::input( ppf::config()->text, 'ppf' . $_SERVER['HTTP_HOST'] );
            require_once(PPF3_ADMIN_DIR . 'src/view/view.php');
            require_once($viewpath);
            new viewHtml();
        }
    }

    protected function execute()
    {
        $arr = explode('.', $this->task);
        $page = $arr[0];
        $task = isset($arr[1])?$arr[1]:'';

        $modelpath = PPF3_ADMIN_DIR . 'src/model/' . $page . '.php';

        if (is_file($modelpath)) {
            require_once(PPF3_ADMIN_DIR . 'src/model/model.php');
            require_once($modelpath);
            $modelname = 'PPF3\\' . $page . 'Model';
            $this->model = new $modelname();
        } else {
            $this->redirect('projects', false);
        }

        if ($task == 'close') {
            $this->redirect($this->model->closelink, false);
        }

        if (in_array($task, array('save', 'saveclose', 'savecreate', 'saveconf', 'publish', 'changedef', 'activate', 'deactivate', 'delete'))) {
            $user = \JFactory::getUser();
            $canDo = $user->authorise('core.edit', 'com_ppf3');

            if(! $canDo) {
                $this->setmessages('PPF_NO_ACL', 'err');
                $this->redirect('projects');
            }
        }

        if (in_array($task, array('save', 'saveclose', 'savecreate', 'saveconf'))) {
            $res = $this->model->save();

            if ($task == 'save') {
                $this->redirect($this->model->savelink.'&id='.$res);
            } elseif ($task == 'saveclose') {
                $this->redirect($this->model->closelink);
            } elseif ($task == 'savecreate') {
                $this->redirect($this->model->savecreatelink);
            } elseif ($task == 'saveconf') {
                $this->redirect($page);
            }

        } elseif ($task == 'filterdir') {
            $this->model->filterdir();
            $this->redirect($this->model->closelink, false);

        } elseif ($task == 'filterlist') {
            $this->model->filterlist($page);
            $this->redirect($this->model->closelink, false);

        } elseif ($task == 'publish') {
            $this->model->publish($page);
            $this->redirect($this->model->closelink, false);

        } elseif ($task == 'activate') {
            $this->model->activate($page);
            $this->redirect($this->model->closelink);

        } elseif ($task == 'deactivate') {
            $this->model->deactivate($page);
            $this->redirect($this->model->closelink);

        } elseif ($task == 'delete') {
            $this->model->delete($page);
            $this->redirect($this->model->closelink);

        } elseif ($task == 'ajax') {
            $this->model->ajax();
            exit;

        } elseif ($task == 'help') {
            $this->model->help();
            exit;
        } elseif ($task == 'chartid') {
            $id = ppf::get('id', $_GET) ? (int) ppf::get('id', $_GET) : '';
            $_SESSION['ppf3']['filterlist']['charts.search'] = $id;
            $this->redirect($this->model->closelink);
        }
    }

}
