<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class fm_activation extends btns
{
  public function getpreForm($fm, $uniq)
  {
    $html = '<form method="POST" name="ppf3_'.$uniq.'">';
    
    $html .= '<div class="ppf_a_drop">';
      $html .= Text::_('PPF_SEND_COD').': <input type="checkbox" onchange="PPF3.a_drop(this)">';
    $html .= '</div>';
    
    $html .= '<div class="ppf_a_drop_inner" style="display:none">';
      $html .= '<div><span>'.Text::_('PPF_A_EMAIL').' *</span><input name="p[email]" type="email" value=""></div>';
      $html .= '<div><span>'.Text::_('PPF_A_HOST').' *</span><input name="p[host]" type="text" value=""></div>';
    $html .= '</div>';

    $html .= '<input type="hidden" name="p[url]" value="'.ppf::getUrl().'"/>';
    $html .= '<input type="hidden" name="p[sum]" value=""/>';
    $html .= '<input type="hidden" name="task" value="psform"/>';
    $html .= '<input type="hidden" name="option" value="com_ppf3"/>';
    $html .= '<input type="hidden" name="fm" value="'.$fm->id.'"/>';
    $html .= '<input type="hidden" name="ps" value=""/>';
    
    $html .= '</form>';
    return $html;
  }
  
  public function afterPay($item, $temp, $realprice) {
    $db = \JFactory::getDbo();
    $db->setQuery("UPDATE #__ppf3_projects SET hits = ( hits + 1 ) WHERE id = ".(int) $item->id);
    $db->execute();
    
    $db->setQuery("UPDATE #__ppf3_ps SET hits = ( hits + 1 ) WHERE id = ".(int) $temp->ps);
    $db->execute();
    
    $activation_cod = $this->customPhp($item, $temp);
    
    $this->mail_cms($item, $temp, $activation_cod);
    return true;
  }
  
  public function paid($fm) {
    $pss = $this->getpss($fm);
    return $this->unpaid($fm, $pss);
  }
  
  public function unpaid($fm, $pss) {
    ppf::addScript('css', 'css/activation.css');
    $fm_params = json_decode($fm->params);

    $uniq = uniqid();
    
    $html = '<div class="ppf_fm_activation">';
    	$html .= '<h4>'.Text::_('PPF_TRANSAC').':</h4>';
      $html .= $this->getpreForm($fm, $uniq);
    
      $html .= '<form class="btns_form">';
      foreach ($pss as $ps)
      {
        $ps_params = json_decode($ps->params);
        
        $html .='<div class="ppf_a_row">';
          $html .= '<div class="ppf3_t">'.Text::_(($title = ppf::get('pstext', $ps_params)) ? $title : $ps->title).'</div>';
          
          if($fm_params->showfield) {
            $html .= '<div><input type="text" id="sum_'.$ps->id.$uniq.'" value="'.$this->recPrice($fm, $ps_params).'" required></div>';
          }
          else {
            $html .= '<div class="ppf3_p">'.$this->recPrice($fm, $ps_params, true).'</div>';
          }

          $html .= '<div>'.Text::_($ps_params->currency).'</div>';
          $html .= '<div>';
            $html .= '<a href="javascript:PPF3.submit(\''.$uniq.'\', '.$ps->id.')">'.Text::_($fm_params->btntext?$fm_params->btntext:$ps_params->btntext).'</a>';
          $html .='</div>';
        $html .='</div>';
      }
      
      $html .= '</form>';
    $html .= '</div>';
    
    if($fm_params->noindex) return '<noindex>'.$html.'</noindex>';
    else return $html;
  }
  
  
  protected function customPhp($item, $temp)
  {
      $fm_params = json_decode($item->params);
      $cod = trim($fm_params->codps);
      if (! $cod)  return '';
      
      $res = '';
      $tmpfname = tempnam(sys_get_temp_dir(), "ppf");
      $handle = fopen($tmpfname, "w");
      fwrite($handle, $cod, strlen($cod));
      fclose($handle);
      if (is_file($tmpfname)) {
          ob_start();
          $res1 = include $tmpfname;
          $res2 = ob_get_clean();
      }
      unlink($tmpfname);
      if($res1) return $res1;
      else return $res2;
  }
  

  public function getPriceValue($fm) {
    return (float) $fm->price;
  }
  
  public function recPrice($fm, $ps_params, $format = false) {
    $fm_params = json_decode($fm->params);
    $price = (float) $fm_params->price2 * $ps_params->ps_multiplier;
    $price = ppf::price()->getPrice($price, $fm->currency, $ps_params->currency, $fm_params->round);
    if($format) return number_format($price, $fm_params->round, ',', ' ');
    else return $price;
  }

  public function mail_cms($item, $temp, $activation_cod) {
    $temp_params = json_decode($temp->params);
    $fm_params = json_decode($item->params);
    
    $mailfrom = \JFactory::getApplication()->get('mailfrom');
    $fromname = \JFactory::getApplication()->get('fromname');
    $to = filter_var(ppf::get('email', $temp_params), FILTER_VALIDATE_EMAIL);
    
    if(! $to || ! ppf::get('host', $temp_params)) return true;
    
    $subject = ppf::get('emailsubj', $fm_params);
    if(! $subject) {
      $subject = 'id:'.$item->historyid.'. Purchase on site '.$_SERVER['HTTP_HOST'];
    }
    $message = ppf::get('emailmes', $fm_params);
    $message = str_replace(['{replacerCod}','{replacerHost}'], [$activation_cod, $temp_params->host], $message);
    $replyto = 0;
    
    $mail = \JFactory::getMailer();
    $mail->addRecipient($to);
    $mail->setSender(array($mailfrom, $fromname));
    $mail->setSubject($subject);
    $mail->setBody($message);
    if ($replyto) {
      $mail->addReplyTo($replyto);
    }
    // $mail->isHTML(true);
    return $mail->Send();
  }

}