<?php
/**
* @Copyright ((c) plasma-web.ru {payperfile id=7}
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class fm_free extends btns
{
  public function paid($fm) {
    $fm_params = json_decode($fm->params);
    $fileName = ppf::get('ppffile', $fm_params);
    
    $name = ppf::get('filetitle', $fm_params);
    if(! $name) $name = $fileName;
    
    $rel = $fm_params->nofollow ? ' rel="nofollow"' : '';
    
    $html = '<a href="index.php?option=com_ppf3&task=download&id='. $fm->id .'"'.$rel.'>'.$name.'</a>';
    
    if (ppf::get('filesize', $fm_params)) {
      $file = ppf::getfolder($fm->id) . $fileName;
      $html .= '<span class="ppfsize">('. $this->size($file) . ')</span>';
    }
    return $html;
  }
  
  public function size($path)
  {
      $bytes = sprintf('%u', filesize($path));
  
      if ($bytes > 0)
      {
          $unit = intval(log($bytes, 1024));
          $units = array('B', 'KB', 'MB', 'GB');
  
          if (array_key_exists($unit, $units) === true)
          {
              return sprintf('%d %s', $bytes / pow(1024, $unit), $units[$unit]);
          }
      }
  
      return $bytes;
  }

}