<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class fm_video extends btns
{
  public function getpreForm($fm, $uniq) {
    $user = \JFactory::getUser();
    $fm_params = json_decode($fm->params);
    
    $html = '<form method="POST" name="ppf3_'.$uniq.'">';
    
    $html .= '<div class="ppf3_visible">';
    
    if(ppf::get('fname', $fm_params)) {
      $html .= '<div class="ppf3_name">';
        $html .= '<label>'.Text::_('PPF_NAME').' *</label>';
        $html .= '<input type="text" name="p[name]" value="'.$user->get('name').'" required/>';
      $html .= '</div>';
    }
    
    if(ppf::get('femail', $fm_params)) {
      $html .= '<div class="ppf3_email">';
        $html .= '<label>'.Text::_('PPF_EMAIL').' *</label>';
        $html .= '<input type="email" name="p[email]" value="'.$user->get('email').'" required/>';
      $html .= '</div>';
    }
      
    $html .= '</div>';
    
    $html .= '<input type="hidden" name="p[url]" value="'.ppf::getUrl().'"/>';
    $html .= '<input type="hidden" name="p[sum]" value=""/>';
    $html .= '<input type="hidden" name="task" value="psform"/>';
    $html .= '<input type="hidden" name="option" value="com_ppf3"/>';
    $html .= '<input type="hidden" name="fm" value="'.$fm->id.'"/>';
    $html .= '<input type="hidden" name="ps" value=""/>';
    $html .= '</form>';
    return $html;
  }
  
  public function afterPay($item, $temp, $realprice) {
    $db = \JFactory::getDbo();
    $db->setQuery("UPDATE #__ppf3_projects SET hits = ( hits + 1 ) WHERE id = ".(int) $item->id);
    $db->execute();
    $db->setQuery("UPDATE #__ppf3_ps SET hits = ( hits + 1 ) WHERE id = ".(int) $temp->ps);
    $db->execute();

    ppf::email()->send($item, $temp);
    return true;

  }
  
  public function unpaid($fm, $pss) {
    $html = $this->getPlayer($fm, false, $pss);
    return $html;
  }
  
  public function paid($fm) {
    $html = $this->getPlayer($fm, true);
    return $html;
  }
  
  public function getPlayer($fm, $paid, $pss = false) {
    $fm_params = json_decode($fm->params);
    $player_payline = '';
    $btns = '';
    
    $file = ppf::get('url', $fm_params);
    $pats = explode($_SERVER['HTTP_HOST'], $file);
    $file = JPATH_ROOT . $pats[1];
    if(! is_file($file)) return '';
    $filesize = filesize($file);
    
    if($paid) $pretime = 101;
    else {
      $pretime = round(ppf::num($fm_params->pretime) * 102400 / $filesize, 2);
      $btns = $this->getvideoBtns($fm, $pss);
      $player_payline .= '<div class="player_payline">preview:<span class="timer">00:00</span><span class="fullbtn">view in full</span></div>';
    }
    
    ppf::addScript('css', 'css/player.css');
    ppf::addScript('js', 'js/player.js');
    
    $poster = $fm_params->poster ? $fm_params->poster : round(ppf::num($fm_params->autoposter) * 102400 / $filesize, 2);
    $strimdata = '{"pretime":"'.$pretime.'","poster":"'.$poster.'"}';

    $html = '';
    $html .= '<div class="ppf3player" data-strim="'.htmlspecialchars($strimdata).'"><div id="player_'.$fm->id.'" class="ppf3_player_inner">
    
      <video preload="metadata">
        <source src="index.php?option=com_ppf3&nocache='.uniqid().'&task=video&id='. $fm->id .'">
      </video>
      <div class="controls">
        '.$btns.'
        <div class="player_poster"></div>
        <div class="player_play">
          <svg viewBox="0 0 16 16" xml:space="preserve">
          <path class="dark" fill="currentColor" d="M8 1c3.9 0 7 3.1 7 7s-3.1 7-7 7-7-3.1-7-7 3.1-7 7-7zM8 0c-4.4 0-8 3.6-8 8s3.6 8 8 8 8-3.6 8-8-3.6-8-8-8v0z"></path><path class="light" fill="currentColor" d="M6 4v8l6-4z"></path></svg>
        </div>
        <div class="progressbar">
          <div class="start"></div>
          <div class="track">
            <progress max="100" value="0" min="0"></progress>
            <input type="range" class="player_range" value="0" min="0" max="100" step="0.1">
            <div class="player_tooltip" style="display:none">00:00</div>
          </div>
          <div class="end"></div>
        </div>
        <div class="player_bottom">
          <div class="player_volume">
            <input class="volume_range" value="0.69" type="range" max="1" min="0" step="0.01">
            <div class="volume_button"></div>
            <div class="rays">
              <div class="hidden volume_mute">×</div>
              <div class="volume_low"></div>
              <div class="volume_middle"></div>
              <div class="volume_high"></div>
            </div>
          </div>
          <div class="player_fullscreen"></div>
        </div>'
        .$player_payline.'
      </div>
      
    </div></div>';
    return $html;
  }
  
  protected function getvideoBtns($fm, $pss) {
    $uniq = uniqid();
    $fm_params = json_decode($fm->params);

    $html = '<div class="ppf3_btns fm_video tmpl_video">';

    $html .= $this->getpreForm($fm, $uniq);
    

    if($pss) {
      $html .= '<form class="btns_form"><div class="ppf3_blocks">';
      $html .= '<div class="ppf3_close">×</div>';

      if($midltext = ppf::get('midltext', $fm_params)) {
        $html .= '<div class="ppf3_midltext">'.$midltext.'</div>';
      }
      
      foreach ($pss as $ps) {
        $ps_params = json_decode($ps->params);
        
        $html .= '<div class="ppf3_block">';
        
          $html .= '<div class="ppf3_title">';
            $html .= ($title = ppf::get('pstext', $ps_params)) ? $title : $ps->title;
          $html .= '</div>';
          
          $html .= '<div class="ppf3_price">';
            if($ps_params->pricerange == '100') {
              $html .= '<input type="text" id="sum_'.$ps->id.$uniq.'" value="'.ppf::price()->full($fm, $ps_params).'" required>';
            }
            else {
              $html .= ppf::price()->full($fm, $ps_params, true);
            }
            $html .= '<span class="ppf3_currency">';
              $html .= Text::_($ps_params->currency);
            $html .= '</span>';
          $html .= '</div>';
          
          $html .= '<div class="ppf3_btn">';
            $html .= '<a href="javascript:PPF3.submit(\''.$uniq.'\', '.$ps->id.')">'.($fm_params->btntext?$fm_params->btntext:$ps_params->btntext).'</a>';
          $html .= '</div>';
          
        $html .= '</div>';
        
        
      }
      $html .= '</div></form>';
    }
    
    $html .= '</div>';
    return Text::translate($html);

  }
  
  public function getPriceValue($fm) {
    return (float) $fm->price;
  }

}