<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class categoriesModel extends baseModel
{
    public $itemscount;

    public function __construct()
    {
        $this->closelink = 'categories';
    }
    
    public function delete($page)
    {
        $db = \JFactory::getDbo();
        $new_id = $this->checkcid();
        if($new_id) {
          if($this->checkParents($new_id)) {
            $db->setQuery( 'DELETE FROM #__ppf3_categories WHERE id IN ('.implode(',', $new_id).')' );
            $db->execute();
            $res = $db->getAffectedRows();
            if($res) $this->messages[] = $res.' '.'PPF_N_ITEMS_DELETED';
            elseif($res === false) $this->errors[] = 'PPF_ERR_DATABASE';
          }
          else {
            $err = ppf::get('categories.checkParent', $_SESSION);
            if(! $err) {
              $this->errors[] = 'PPF_CANNOTDO';
              $_SESSION['categories.checkParent']='er1';
            }
            elseif($err == 'er1') {
              $this->errors[] = 'PPF_CANNOTDO2';
              $_SESSION['categories.checkParent']='er2';
            }
            else {
              $this->errors[] = 'You cannot leave a child without a parent.';
            }
          }
        }
    }
    
    public function checkParents($ids) {
      foreach($ids as $id) {
        $tree = ppf::categories()->categoriesTree($id);
        if($tree) {
          if(! $this->checkTree($tree, $id)) return false;
        }
      }
      return true;
    }
    public function checkTree($tree, $id) {
      foreach($tree as $cat) {
        if($cat->id == $id) return true;
        if($cat->child) {
          if($this->checkTree($cat->child, $id)) return true;
        }
      }
      return false;
    }


    public function getItems() {
      $tree = $this->getItemscic(0);
      return $this->catlist($tree);
    }

    public function getItemscic($parent)
    {
        $db = \JFactory::getDbo();

        $ses = ppf_session::get('ppf3');
        $filterdir = ppf::get('filterdir', $ses, []);

        $order = ppf::get('order', $filterdir, 'rating');
        if(! in_array($order, array('published', 'title', 'id', 'parent', 'access', 'language'))) {
            $order = 'rating';
        }
        $dir = ppf::get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';

        $limit = 12;

        if (! $filterdir) {
            $_SESSION['ppf3']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = ppf::get('filterlist', $ses, []);
        $where = array();
        $where[] = 'parent='. (int) $parent;

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'categories.published') $where[] = 'published='. (int) $v;
            elseif($v && $k == 'categories.language') $where[] = 'language="'. addslashes( $v ) . '"';
            elseif($v && $k == 'categories.access') $where[] = 'access="'. addslashes( $v ) . '"';
            elseif($v && $k == 'categories.limit') $limit = (int) $v;
        }

        $active = (int) ppf::get('start', $_GET, 1);
        $start = ($active-1)*$limit;

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';
        
        if(! $parent) {
          $limit = ' LIMIT ' .$start. ',' .$limit;
        }
        else {
          $limit = '';
        }

        $db->setQuery( 'SELECT * FROM #__ppf3_categories' .$where. ' ORDER BY ' .$order. ' ' .$dir.$limit );
        $data = $db->loadObjectList();
        
        foreach($data as &$dat) {
          $dat->child = $this->getItemscic($dat->id);
        }
        
        if(! $parent) {
          $db->setQuery( 'SELECT COUNT(*) FROM #__ppf3_categories' .$where );
          $this->itemscount = $db->loadResult();
        }

        return $data;
    }
    
    public function catlist($tree, $i = 0) {
      static $opt = array();
      $i++; $d = '';
      for($ii=$i; $ii>0; $ii--) $d .= ' — ';
      foreach($tree as &$cat) {
        $cat->title = $d.$cat->title;
        $opt[] = $cat;
        if($cat->child) {
          $this->catlist($cat->child, $i);
        }
      }
      return $opt;
    }
    
}
