<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class categoryModel extends baseModel
{
    public function __construct()
    {
        $this->closelink = 'categories';
        $this->savelink = 'categories&task=category.edit';
    }

    public function getItems()
    {
        $task = ppf::gettask();

        if ($task != 'category.edit') {
            return;
        }
      
        $db = \JFactory::getDbo();
        $db->setQuery("SELECT * FROM #__ppf3_categories WHERE id = " . (int) $this->get('id', $_GET));
        $data = $db->loadObject();
        
        $params = json_decode($data->params);
        if ($params) {
            foreach ($params as $name => $value) {
                $dname = 'p]['.$name;
                $data->$dname = $value;
            }
        }
        unset($data->params);
        return $data;
    }

    public function save()
    {
        $db = \JFactory::getDbo();

        $data = filter_input(INPUT_POST, 'ppffield', FILTER_DEFAULT , FILTER_REQUIRE_ARRAY);
        $id = (int) $this->get('id', $_GET, 0);


        if (! $data['title']) {
            $this->errors[] = 'The title is not filled in.';
            return (int) $data['id'];
        }
        
        if (! $this->checkParent($data)) {
            $err = $this->get('category.checkParent', $_SESSION);
            if(! $err) {
              $this->errors[] = 'PPF_CANNOTDO';
              $_SESSION['category.checkParent']='er1';
            }
            elseif($err == 'er1') {
              $this->errors[] = 'PPF_CANNOTDO2';
              $_SESSION['category.checkParent']='er2';
            }
            else {
              $this->errors[] = 'PPF_CANNOTDO3';
            }
            
            $this->closelink = 'categories&task=category.edit&id='.$data['id'];
            return (int) $data['id'];
        }
        
        $datap = json_encode($data['p'], JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES | JSON_NUMERIC_CHECK);

        $inputData = array(
            'title' 	=> '\''.addslashes(strip_tags($data['title'])).'\'',
            'id' 	=> (int) $data['id'],
            'published'    => (int) $data['published'],
            'access'   => (int) $data['access'],
            'language'   => '\''.addslashes($data['language']).'\'',
            'parent'   => (int) $data['parent'],
            'rating'   => (int) $data['rating'],
            'params'   => '\''.addslashes($datap).'\'',
         );

         if ($inputData['id']) {
             foreach ($inputData as $key => $value) {
                 $updates[] = $key .' = '. $value;
             }
             $db->setQuery("UPDATE #__ppf3_categories SET ".implode(', ', $updates). " WHERE id=".(int) $inputData['id']);
             $db->execute();
             return $inputData['id'];
         } else {
             $db->setQuery("INSERT INTO #__ppf3_categories (".implode(',', array_keys($inputData)).") VALUES (".implode(',', array_values($inputData)).")");
             $db->execute();
             return $db->insertid();
         }
    }

    public function checkParent($data) {
      if($data['parent'] && $data['id']) {
        if($data['id'] == $data['parent']) return false;
        $tree = ppf::categories()->categoriesTree($data['id']);
        return $this->checkTree($tree, $data['parent']);
      }
      return true;
    }
    
    public function checkTree($tree, $id) {
      foreach($tree as $cat) {
        if($cat->id == $id) return false;
        if($cat->child) {
          if(! $this->checkTree($cat->child, $id)) return false;
        }
      }
      return true;
    }

}
