<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class chartsModel extends baseModel
{
    public function __construct()
    {
        $this->closelink = 'charts';
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();
        $ses = ppf_session::get('ppf3');

        $filterlist = ppf::get('filterlist', $ses, []);
        $where = array();

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'charts.published') $where[] = 'published='. (int) $v;
            elseif($v && $k == 'charts.currency') $where[] = 'currency="'. addslashes( $v ) . '"';
            elseif($v && $k == 'charts.fm') $where[] = 'fm="'. addslashes( $v ) . '"';
            elseif($v && $k == 'charts.ps') $where[] = 'ps='. (int) $v;
            elseif($v && $k == 'charts.start') $where[] = 'date > '. (int) strtotime($v);
            elseif($v && $k == 'charts.end') $where[] = 'date < '. (int) (strtotime($v)+24*3600);
            elseif($v && $k == 'charts.categories') {
              $tree = ppf::categories()->categoriesTree((int) $v);
              $opts = ppf::categories()->catlist($tree);
              $where2[] = 'params RLIKE \'"cat":"[^"]*[^\d]?' .(int)$v. '[^\d]?.*"\'';
              foreach($opts as $key=>$vv) {
                $where2[] = 'params RLIKE \'"cat":"[^"]*[^\d]?' .(int)$key. '[^\d]?.*"\'';
              }
              $where[] = '('.implode(' OR ', $where2).')';
            } 
            elseif($v && $k == 'charts.search') {
              if($v == (int) $v) $where[] = 'projectid='. (int) $v;
              else{
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(reqparams LIKE ' . $v . ' OR params LIKE ' . $v . ')';
              }
            }
        }

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';

        $db->setQuery( 'SELECT * FROM #__ppf3_history' .$where. ' ORDER BY date');
        return $db->loadObjectList();
    }
    
}
