<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class baseModel extends ppf_admin
{
    public $closelink;
    public $savelink;
    public $savecreatelink;

    public function filterdir() {
        $col = ppf::gettask('col');
        $ses = ppf_session::get('ppf3');
        $filter = ppf::get('filterdir', $ses, []);
        $order = ppf::get('order', $filter, 'id');

        if($col == $order) {
            $dir = ppf::get('dir', $filter) === 'asc' ? 'desc' : 'asc';
            $_SESSION['ppf3']['filterdir']['dir'] = $dir;
        }
        else {
            $_SESSION['ppf3']['filterdir']['order'] =  $col;
        }

    }

    public function filterlist($page)
    {
        $col = filter_input(INPUT_POST, 'col', FILTER_SANITIZE_STRING);
        $v = filter_input(INPUT_POST, 'v', FILTER_SANITIZE_FULL_SPECIAL_CHARS);

        if($col) $_SESSION['ppf3']['filterlist'][$page.'.'.$col] = $v;
    }

    public function publish($page)
    {
        if(! in_array($page, array('projects', 'ps', 'categories', 'history'))) return;

        $db = \JFactory::getDbo();
        $db->setQuery( 'UPDATE #__ppf3_'.$page.' SET published = 1 - published WHERE id=' .(int) $_GET['id'] );
        $db->execute();
    }

    public function activate($page)
    {
        if(! in_array($page, array('projects', 'ps', 'categories', 'history'))) return;
        
        $db = \JFactory::getDbo();
        $new_id = $this->checkcid();
        if($new_id) {
            $db->setQuery( 'UPDATE #__ppf3_'.$page.' SET published = 1 WHERE id IN ('.implode(',', $new_id).')' );
            $db->execute();
            $res = $db->getAffectedRows();
            if($res) $this->setmessages($res.' '.'PPF_N_ITEMS_PUBLISHED', 'mes');
            elseif($res === false) $this->setmessages('PPF_ERR_DATABASE', 'err');
        }
    }

    public function deactivate($page)
    {
        if(! in_array($page, array('projects', 'ps', 'categories', 'history'))) return;

        $db = \JFactory::getDbo();
        $new_id = $this->checkcid();
        if($new_id) {
            $db->setQuery( 'UPDATE #__ppf3_'.$page.' SET published = 0 WHERE id IN ('.implode(',', $new_id).')' );
            $db->execute();
            $res = $db->getAffectedRows();
            if($res) $this->setmessages($res.' '.'PPF_N_ITEMS_UNPUBLISHED', 'mes');
            elseif($res === false) $this->setmessages('PPF_ERR_DATABASE', 'err');
        }
    }

    public function delete($page)
    {
        if(! in_array($page, array('projects', 'ps', 'history'))) return;

        $db = \JFactory::getDbo();
        $new_id = $this->checkcid();
        if($new_id) {
            $db->setQuery( 'DELETE FROM #__ppf3_'.$page.' WHERE id IN ('.implode(',', $new_id).')' );

            $db->execute();
            $res = $db->getAffectedRows();
            
            if($res) $this->setmessages($res.' '.'PPF_N_ITEMS_DELETED', 'mes');
            elseif($res === false) $this->setmessages('PPF_ERR_DATABASE', 'err');
        }
    }

    protected function checkcid()
    {
        return array_diff(filter_input(INPUT_POST, 'cid', FILTER_SANITIZE_NUMBER_INT , FILTER_REQUIRE_ARRAY), array(''));
    }

    public function help()
    {
        echo Text::_('PPF_HELP');
    }

}
