<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class projectsModel extends baseModel
{
    public $itemscount;

    public function __construct()
    {
        $this->closelink = 'projects';
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();

        $ses = ppf_session::get('ppf3');
        $filterdir = ppf::get('filterdir', $ses, []);

        $order = ppf::get('order', $filterdir, 'id');
        if(! in_array($order, array('published', 'title', 'hits', 'rating', 'categories', 'price', 'currency', 'access', 'language'))) {
            $order = 'id';
        }
        $dir = ppf::get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';

        $limit = 12;

        if (! $filterdir) {
            $_SESSION['ppf3']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = ppf::get('filterlist', $ses, []);
        $where = array();

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'projects.published') $where[] = 'published='. (int) $v;
            elseif($v && $k == 'projects.language') $where[] = 'language="'. addslashes( $v ) . '"';
            elseif($v && $k == 'projects.access') $where[] = 'access="'. addslashes( $v ) . '"';
            elseif($v && $k == 'projects.categories') {
              $tree = ppf::categories()->categoriesTree((int) $v);
              $opts = ppf::categories()->catlist($tree);
              $where2[] = 'categories RLIKE \'(^|.*,)' .(int)$v. '($|,.*)\'';
              foreach($opts as $key=>$v) {
                $where2[] = 'categories RLIKE \'(^|.*,)' .(int)$key. '($|,.*)\'';
              }
              $where[] = '('.implode(' OR ', $where2).')';
            } 
            elseif($v && $k == 'projects.search') {
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(title LIKE ' . $v . ' OR params LIKE ' . $v . ')';
            }
            elseif($v && $k == 'projects.limit') $limit = (int) $v;
        }

        $active = (int) ppf::get('start', $_GET, 1);
        $start = ($active-1)*$limit;

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';

        $db->setQuery( 'SELECT * FROM #__ppf3_projects' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit );
        $data = $db->loadObjectList();

        $db->setQuery( 'SELECT COUNT(*) FROM #__ppf3_projects' .$where );
        $this->itemscount = $db->loadResult();

        return $data;
    }

    public function delete($page)
    {
    }

}
