<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class psModel extends baseModel
{
    public function __construct()
    {
        $this->closelink = 'pss';
        $this->savelink = 'pss&task=ps.edit';
    }

    public function getItems()
    {
        $task = ppf::gettask();

        if ($task != 'ps.edit') {
            return;
        }
      
        $db = \JFactory::getDbo();
        $db->setQuery("SELECT * FROM #__ppf3_ps WHERE id = " . (int) ppf::get('id', $_GET));
        $data = $db->loadObject();
        
        $params = json_decode($data->params);
        if ($params) {
            foreach ($params as $name => $value) {
                $dname = 'p]['.$name;
                $data->$dname = $value;
            }
        }
        unset($data->params);
        return $data;
    }

    public function save()
    {
        $db = \JFactory::getDbo();

        $data = filter_input(INPUT_POST, 'ppffield', FILTER_DEFAULT , FILTER_REQUIRE_ARRAY);
        $id = (int) ppf::get('id', $_GET, 0);


        if (! $data['title']) {
            $this->errors[] = 'The title is not filled in.';
            return (int) $data['id'];
        }
        
        $datap = json_encode($data['p'], JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);

        $inputData = array(
            'title' 	=> '\''.addslashes(strip_tags($data['title'])).'\'',
            'id' 	=> (int) $data['id'],
            'published'    => (int) $data['published'],
            'access'   => (int) $data['access'],
            'language'   => '\''.addslashes($data['language']).'\'',
            'ps'   => '\''.addslashes($data['ps']).'\'',
            'hits'   => (int) $data['hits'],
            'params'   => '\''.addslashes($datap).'\'',
         );

         if ($inputData['id']) {
             foreach ($inputData as $key => $value) {
                 $updates[] = $key .' = '. $value;
             }
             $db->setQuery("UPDATE #__ppf3_ps SET ".implode(', ', $updates). " WHERE id=".(int) $inputData['id']);
             $db->execute();
             return $inputData['id'];
         } else {
             $db->setQuery("INSERT INTO #__ppf3_ps (".implode(',', array_keys($inputData)).") VALUES (".implode(',', array_values($inputData)).")");
             $db->execute();
             return $db->insertid();
         }
    }


}
