<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class pssModel extends baseModel
{
    public $itemscount;

    public function __construct()
    {
        $this->closelink = 'pss';
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();

        $ses = ppf_session::get('ppf3');
        $filterdir = ppf::get('filterdir', $ses, []);

        $order = ppf::get('order', $filterdir, 'id');
        if(! in_array($order, array('published', 'title', 'hits', 'ps', 'access', 'language'))) {
            $order = 'id';
        }
        $dir = ppf::get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';

        $limit = 12;

        if (! $filterdir) {
            $_SESSION['ppf3']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = ppf::get('filterlist', $ses, []);
        $where = array();

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'pss.published') $where[] = 'published='. (int) $v;
            elseif($v && $k == 'pss.language') $where[] = 'language="'. addslashes( $v ) . '"';
            elseif($v && $k == 'pss.access') $where[] = 'access="'. addslashes( $v ) . '"';
            elseif($v && $k == 'pss.search') {
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(title LIKE ' . $v . ' OR params LIKE ' . $v . ')';
            }
            elseif($v && $k == 'pss.limit') $limit = (int) $v;
        }

        $active = (int) ppf::get('start', $_GET, 1);
        $start = ($active-1)*$limit;

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';

        $db->setQuery( 'SELECT * FROM #__ppf3_ps' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit );
        $data = $db->loadObjectList();

        $db->setQuery( 'SELECT COUNT(*) FROM #__ppf3_ps' .$where );
        $this->itemscount = $db->loadResult();

        return $data;
    }
    
}
