<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class saleModel extends baseModel
{
    public function __construct()
    {
        $this->closelink = 'sales';
        $this->savelink = 'sales&task=sale.edit';
    }

    public function getItems()
    {
        $task = ppf::gettask();

        if ($task != 'sale.edit') {
            return;
        }

        $db = \JFactory::getDbo();
        $db->setQuery("SELECT * FROM #__ppf3_history WHERE id = " .(int) ppf::get('id', $_GET));
        $data = $db->loadObject();

        $params = json_decode($data->params);
        if ($params) {
            foreach ($params as $name => $value) {
                $dname = 'p]['.$name;
                $data->$dname = $value;
            }
        }
        return $data;
    }

    public function save()
    {
        $db = \JFactory::getDbo();

        $data = filter_input(INPUT_POST, 'ppffield', FILTER_DEFAULT , FILTER_REQUIRE_ARRAY);
        $id = (int) ppf::get('id', $_GET, 0);

        if (! $data['date']) {
            $this->errors[] = 'The date is not filled in.';
            return (int) $data['id'];
        }

        $params = json_encode($data['p'], JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES | JSON_NUMERIC_CHECK);

        $inputData = array(
            'id' 	=> (int) $data['id'],
            'published'    => (int) $data['published'],
            'date'   => (int) $data['date'],
            'enddate'   => (int) $data['enddate'],
            'projectid'   => (int) $data['projectid'],
            'price'   => (float) $data['price'],
            'currency'   => '\''.addslashes($data['currency']).'\'',
            'user'   => (int) $data['user'],
            'ps'   => (int) $data['ps'],
            'fm'   => '\''.addslashes($data['fm']).'\'',
            'ses_id'   => '\''.addslashes($data['ses_id']).'\'',
            'temp_id'   => (int) $data['temp_id'],
            'params'   => '\''.addslashes($params).'\'',
         );

        if ($inputData['id']) {
            foreach ($inputData as $key => $value) {
                $updates[] = $key .' = '. $value;
            }
            $db->setQuery("UPDATE #__ppf3_history SET ".implode(', ', $updates). " WHERE id=".(int) $inputData['id']);
            $db->execute();
            return $inputData['id'];
        } else {
            $db->setQuery("INSERT INTO #__ppf3_history (".implode(',', array_keys($inputData)).") VALUES (".implode(',', array_values($inputData)).")");
            $db->execute();
            return $db->insertid();
        }
    }
    
    public function publish($page) {
      parent::publish('history');
    }
    
    public function delete($page) {
      parent::delete('history');
    }

}
