<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class salesModel extends baseModel
{
    public $itemscount;

    public function __construct()
    {
        $this->closelink = 'sales';
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();
        $ses = ppf_session::get('ppf3');
        $filterdir = ppf::get('filterdir', $ses, []);

        $order = ppf::get('order', $filterdir, 'a.id');
        if(! in_array($order, array('published', 'date', 'fm', 'ps', 'title', 'price', 'currency','user'))) {
            $order = 'a.id';
        }
        $dir = ppf::get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';

        $limit = 12;

        if (! $filterdir) {
            $_SESSION['ppf3']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = ppf::get('filterlist', $ses, []);
        $where = array();

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'sales.published') $where[] = 'a.published='. (int) $v;
            elseif($v && $k == 'sales.fm') $where[] = 'a.fm="'. addslashes( $v ) . '"';
            elseif($v && $k == 'sales.ps') $where[] = 'a.ps="'. addslashes( $v ) . '"';
            elseif($v && $k == 'sales.search') {
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(a.reqparams LIKE ' . $v . ' OR a.params LIKE ' . $v . ')';
            }
            elseif($v && $k == 'sales.limit') $limit = (int) $v;
        }

        $active = (int) ppf::get('start', $_GET, 1);
        $start = ($active-1)*$limit;

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';

        $db->setQuery( 'SELECT a.*, b.title, c.title as pstitle FROM #__ppf3_history a LEFT JOIN #__ppf3_projects b ON a.projectid = b.id LEFT JOIN #__ppf3_ps c ON a.ps = c.id' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit );
        $data = $db->loadObjectList();

        $db->setQuery( 'SELECT COUNT(*) FROM #__ppf3_history a ' .$where );
        $this->itemscount = $db->loadResult();

        return $data;
    }
    
}
