<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class ps_robokassa extends btns
{
	public function getPsForm($id, $item, $post) {
		$fm_params = json_decode($item->params);
    $ps_params = json_decode($item->psparams);
		
		$mrh_login = trim($ps_params->purse);
		$inv_id = $id;
		$mrh_pass1 = trim($ps_params->secret_key1);
		
		if($fm_params->showfield) {
			$out_summ = (float) ppf::get('sum', $post['p'], 0);
		}
		elseif((int) $ps_params->pricerange >= 100 && (float) ppf::get('sum', $post['p'])) {
			$item->price = (float) $post['p']['sum'];
			$out_summ = ppf::price()->full($item, $ps_params);
		}
		else {
			$out_summ = ppf::price()->full($item, $ps_params);
		}
		
		$email = ppf::get('femail', $post['p']);

		$crc  = md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1");
    $action='https://auth.robokassa.ru/Merchant/Index.aspx';
    
    $html  = '<form name="ppf3" action="'.$action.'" method="POST">';
    $html .= '<input type="hidden" name="MerchantLogin" value="'.$mrh_login.'">';
		$html .= '<input type="hidden" name="InvId" value="'.$inv_id.'">';
    $html .= '<input type="hidden" name="Description" value="'.$fm_params->desc.'">';
    $html .= '<input type="hidden" name="SignatureValue" value="'.$crc.'">';
		$html .= '<input type="hidden" name="OutSum" value="'. $out_summ.'">';
		$html .= '<input type="hidden" name="Encoding" value="utf-8">';
		if($ps_params->test) $html .= '<input type="hidden" name="IsTest" value="1">';
		if($email) $html .= '<input type="hidden" name="Email" value="'. $email.'">';
    $html .= '</form>';
    $html .= '<script type="text/javascript">document.forms.ppf3.submit();</script>';
    return $html;
	}
	
	public function checkPsRes() {
		$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
		
		if (! isset($post['InvId']) || ! $post['InvId'] || $post['InvId'] != (int) $post['InvId']) {
				die("err1");
		}
		
		$temp = $this->getTemp($post['InvId']);
		if(! $temp) die("err3");

		$mod = ppf::gettask('mod');
		
		if($mod == 'res') {
			$item = $this->getItemForHistory($temp);
			if(! $item) die("err4");
	
			$ps_params = json_decode($item->psparams);
			if(! $ps_params) die("err5");
			
			$realprice = $_REQUEST["OutSum"];
			$inv_id = $_REQUEST["InvId"];
			$mrh_pass2 = trim($ps_params->secret_key2);
			
			$my_crc = strtoupper(md5("$realprice:$inv_id:$mrh_pass2"));
			if($my_crc !== strtoupper($_REQUEST["SignatureValue"])) {
				echo "bad sign\n";
			  exit();
			}
			
			if ($this->insertHistory($post, $temp, $item, $realprice)) {
				echo "OK$inv_id\n";
				exit;
			}
			 
	    die("err9");
		}
		elseif($mod == 'suc') {
			session_start();
			$app = \JFactory::getApplication();
			$temp_params = json_decode($temp->params);
			$app->enqueueMessage(Text::_('PPF_SUC'), 'message');
			$app->redirect($temp_params->url);
			exit;
		}
		elseif($mod == 'fail') {
			session_start();
			$app = \JFactory::getApplication();
			$temp_params = json_decode($temp->params);
			$app->enqueueMessage(Text::_('PPF_FAIL'), 'error');
			$app->redirect($temp_params->url);
			exit;
		}
	}
	
}
