<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class ps_webmoney extends btns
{
	public function getPsForm($id, $item, $post) {
		$fm_params = json_decode($item->params);
		$ps_params = json_decode($item->psparams);

		$action='https://merchant.webmoney.ru/lmi/payment_utf.asp';
		
		$html  = '<form name="ppf3" action="'.$action.'" method="POST">';
		$html .= '<input type="hidden" name="LMI_PAYEE_PURSE" value="'.$ps_params->purse.'">';
		
		if($ps_params->sim_mode !== '') {
			$html .= '<input type="hidden" name="LMI_SIM_MODE" value="'.$ps_params->sim_mode.'">';
		}
		
		if((int) $ps_params->invoicing) {
			$html .= '<input type="hidden" name="LMI_ALLOW_SDP" value="'.$ps_params->invoicing.'">';
		}
		
		if($fm_params->showfield) {
			$html .= '<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="'. (float) ppf::get('sum', $post['p'], 0).'">';
		}
		elseif((int) $ps_params->pricerange > 100 && (float) ppf::get('sum', $post['p'])) {
			$item->price = (float) $post['p']['sum'];
			$html .= '<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="'.ppf::price()->full($item, $ps_params).'">';
		}
		else {
			$html .= '<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="'.ppf::price()->full($item, $ps_params).'">';
		}
		
		$html .= '<input type="hidden" name="LMI_PAYMENT_DESC" value="'.$fm_params->desc.'">';
		$html .= '<input type="hidden" name="LMI_PAYMENT_NO" value="'.$id.'">';
		
		$resurl = ((! empty($_SERVER['HTTPS'])) ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'] . '/index.php?option=com_ppf3&task=resurl&result=ps_webmoney';
		$html .= '<input type="hidden" name="LMI_RESULT_URL" value="'.$resurl.'&mod=res">';
		
		$html .= '<input type="hidden" name="LMI_FAIL_URL" value="'.$resurl.'&mod=fail">';
		$html .= '<input type="hidden" name="LMI_SUCCESS_URL" value="'.$resurl.'&mod=suc">';
		$html .= '<input type="hidden" name="LMI_SUCCESS_METHOD" value="1">';
		$html .= '<input type="hidden" name="LMI_FAIL_METHOD" value="1">';
		// $html .= '<input type="hidden" name="LMI_HIDE_DISABLED" value="1">';
		$html .= '</form>';
		$html .= '<script type="text/javascript">document.forms.ppf3.submit();</script>';
		return $html;
	}
	
	public function checkPsRes() {
		$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
		
		if (! isset($post['LMI_PAYMENT_NO']) || ! $post['LMI_PAYMENT_NO'] || $post['LMI_PAYMENT_NO'] != (int) $post['LMI_PAYMENT_NO']) {
        die("err1");
    }
		
		$temp = $this->getTemp($post['LMI_PAYMENT_NO']);
		if(! $temp) die("err3");
		
		$mod = ppf::gettask('mod');
		if ($mod == 'suc') {
			session_start();
			$app = \JFactory::getApplication();
			$temp_params = json_decode($temp->params);
			$app->enqueueMessage(Text::_('PPF_SUC'), 'message');
			$app->redirect($temp_params->url);
			exit;
		}
		elseif ($mod == 'fail') {
			session_start();
			$app = \JFactory::getApplication();
			$temp_params = json_decode($temp->params);
			$app->enqueueMessage(Text::_('PPF_FAIL'), 'error');
			$app->redirect($temp_params->url);
			exit;
		}

		
		$item = $this->getItemForHistory($temp);
		if(! $item) die("err4");

		$ps_params = json_decode($item->psparams);
		if(! $ps_params) die("err5");
		
		$range = (float) trim($ps_params->pricerange);
		
		if($range < 100) {
			$price = ppf::price()->full($item, $ps_params);
			
			if($post['LMI_PAYMENT_AMOUNT'] < ($price - $price*$range/100)) {
				die("ERR: INCORRECT AMOUNT");
			}
		}

		if($post['LMI_PREREQUEST'] == 1)
		{
			if($post['LMI_PAYEE_PURSE'] != $ps_params->purse) {
				echo "ERR: INCORRECT PAYEE PURSE ".$post['LMI_PAYEE_PURSE'];
				exit;
		  }
		  echo "YES";
			exit;
		}
		else {
			
			$common_string = $_POST['LMI_PAYEE_PURSE'] . $_POST['LMI_PAYMENT_AMOUNT'] .  $_POST['LMI_PAYMENT_NO'] . $_POST['LMI_MODE'] . $_POST['LMI_SYS_INVS_NO'] .  $_POST['LMI_SYS_TRANS_NO'] . $_POST['LMI_SYS_TRANS_DATE'] . $ps_params->secret_key .  $_POST['LMI_PAYER_PURSE'] . $_POST['LMI_PAYER_WM'];
			 
		  if(strtoupper(hash('sha256', $common_string)) !== strtoupper($_POST['LMI_HASH'])) exit;
			
			
			$realprice = $post['LMI_PAYMENT_AMOUNT'];
			
			if ($this->insertHistory($post, $temp, $item, $realprice)) {
					 echo "YES";
					 exit;
			}

			die("err9");
		}

	}

}
