<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class ps_yoomoney extends btns
{
  public function getPsForm($id, $item, $post) {
    $fm_params = json_decode($item->params);
    $ps_params = json_decode($item->psparams);

    $action='https://yoomoney.ru/quickpay/confirm.xml';
    
    $html  = '<form name="ppf3" action="'.$action.'" method="POST">';
    $html .= '<input type="hidden" name="receiver" value="'.$ps_params->purse.'">';
    $html .= '<input type="hidden" name="quickpay-form" value="shop">';
    $html .= '<input type="hidden" name="targets" value="'.$fm_params->desc.'">';
    $html .= '<input type="hidden" name="paymentType" value="'.$ps_params->invoicing.'">';
    
    if($fm_params->showfield) {
      $html .= '<input type="hidden" name="sum" value="'. (float) ppf::get('sum', $post['p'], 0).'">';
    }
    elseif((int) $ps_params->pricerange >= 100 && (float) ppf::get('sum', $post['p'])) {
      $item->price = (float) $post['p']['sum'];
      $html .= '<input type="hidden" name="sum" value="'.ppf::price()->full($item, $ps_params).'">';
    }
    else {
      $html .= '<input type="hidden" name="sum" value="'.ppf::price()->full($item, $ps_params).'">';
    }
    
    $html .= '<input type="hidden" name="formcomment" value="'.$fm_params->desc.'">';
    $html .= '<input type="hidden" name="short-dest" value="'.$fm_params->desc.'">';
    $html .= '<input type="hidden" name="label" value="'.$id.'">';
    
    $success = $post['p']['url'];
    if (! isset($_GET['ppf3success'])) {
      $success .= (! strpos($success, '?') ? '?' : '&') . 'ppf3success=1';
    }
    $html .= '<input type="hidden" name="successURL" value="'.$success.'">';
    
    $html .= '</form>';
    $html .= '<script type="text/javascript">document.forms.ppf3.submit();</script>';
    return $html;
  }
  
  
  public function checkPsRes() {
    
    $post = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
    
    if (! isset($post['label']) || ! $post['label'] || $post['label'] != (int) $post['label']) {
      echo "OK";
      exit;
    }
    
    if (! isset($post['currency']) || ! isset($post['sha1_hash']) || $post['currency'] != '643' || $post['codepro'] != 'false' || $post['unaccepted'] != 'false') {
        die("err2");
    }
    
    $temp = $this->getTemp($post['label']);
    if(! $temp) die("err3");
    
    $item = $this->getItemForHistory($temp);
    if(! $item) die("err4");

    $ps_params = json_decode($item->psparams);
    if(! $ps_params) die("err5");
    
    $common_string = $post['notification_type'] .'&'. $post['operation_id'] .'&'. $post['amount'] .'&'. $post['currency'] .'&'. $post['datetime'] .'&'. $post['sender'] .'&'. $post['codepro'] .'&'. $ps_params->secret_key .'&'. $post['label'];
    
    if (sha1($common_string) !== $post['sha1_hash']) {
        die("err6");
    }
    
    $realprice = $post['amount'];
    $range = (float) trim($ps_params->pricerange);
    
    if($range < 100) {
      $price = ppf::price()->full($item, $ps_params);
      
      if($realprice < ($price - $price*$range/100)) {
        die("err8");
      }
    }
    
    if ($this->insertHistory($post, $temp, $item, $realprice)) {
         echo "OK";
         exit;
    }
    
     die("err9");
  }

}

