<?php
/**
* @Copyright ((c) plasma-web.ru
		* @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class viewHtml extends baseView
{
	protected $items;

    public function __construct()
    {
        parent::__construct('categories');
        $this->display();
    }

    public function display()
    {
        $this->items = $this->getItems();
        $this->pagination = $this->getPagination();

        $this->addToolbar();
        $this->addFilters();

        parent::display();
    }

    protected function addToolbar()
    {
		$this->settitle('PPF-3. PPF_CATEGORIES_LIST');

        $html = '<div class="ppf3_toolbar">';
        $html .= $this->toolbarBtn('category.add', 'PPF_ADD_NEW', ' green');
        $html .= $this->toolbarBtn('categories.activate', 'PPF_ACTIVATE', ' gray');
        $html .= $this->toolbarBtn('categories.deactivate', 'PPF_DEACTIVATE', ' gray');
        $html .= $this->toolbarBtn('categories.delete', 'Delete', ' red');
        $html .= $this->toolbarBtn('categories.help', 'Help', '');
        $html .= '</div>';
        echo $html;
    }

    protected function addFilters()
    {
        $html = '<div class="ppf3_filters">';

        $html .= $this->filter('categories.published', [''=>'PPF_STATE', 1=>'PPF_PUBLISHED', 0=>'PPF_UNPUBLISHED']);
        $html .= $this->filter('categories.language', $this->getLanguages());
        $html .= $this->filter('categories.access', ppf::getacs());
        $html .= $this->filter('categories.limit', [''=>'12', 24=>'24', 48=>'48']);

        $html .= '</div>';
        echo $html;
    }

}
