<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class viewHtml extends baseView
{
    protected $items;

    public function __construct()
    {
        parent::__construct('charts');
        $this->display();
    }

    public function display()
    {
        $this->addFilters();
        $this->items = $this->getItems();

        parent::display();
    }

    protected function addFilters()
    {
        function getfm(){
          $path = PPF3_ADMIN_DIR . 'src/fm';
          $scans = scandir($path);
          $fm[''] = 'fm';
          foreach($scans as $scan) {
            if($scan !='.' && $scan !='..' && is_dir($path.'/'.$scan)) {
              $xml = simplexml_load_file($path.'/'.$scan.'/'.$scan.'.xml');
              $fm[$scan] = Text::_((string)$xml->name);
            }
          }
          return $fm;
        }
        
        function getps() {
          $db = \JFactory::getDbo();
          $arr[''] = 'ps';
          $db->setQuery( 'SELECT id, title FROM #__ppf3_ps');
          $data = $db->loadObjectList();
          foreach($data as $dat) {
            $arr[$dat->id] = $dat->title;
          }
          return $arr;
        }
        
        $curr = explode(',', ppf::config()->currency);
        $filtercurrency[''] = 'PPF_CURRENCY_2';
        foreach($curr as $cur){
          $filtercurrency[trim($cur)] = $cur;
        }
        
        $ses = ppf_session::get('ppf3');
        $filterlist = ppf::get('filterlist', $ses, []);
        
        $pattern = ppf::get('charts.pattern', $filterlist);
        if(! $pattern) $_SESSION['ppf3']['filterlist']['charts.pattern'] = 'ym';
        
        if(! isset($_SESSION['ppf3']['filterlist']['charts.published'])) {
          $_SESSION['ppf3']['filterlist']['charts.published'] = 1;
        } 

        $end = ppf::get('charts.end', $filterlist);
        if(! $end) $_SESSION['ppf3']['filterlist']['charts.end'] = date('Y-m-d');
        
        $start = ppf::get('charts.start', $filterlist);
        if(! $start || $start[0] != '2') $_SESSION['ppf3']['filterlist']['charts.start'] = date('Y-m-d', strtotime("-1 year"));

        $html = '<div class="ppf3_filters">';
        $html .= $this->filtersearch('charts.search');
        $html .= $this->filtertext('charts.start');
        $html .= $this->filtertext('charts.end');
        $html .= $this->filter('charts.categories', array(''=>'PPF_CATEGORY')+ppf::categories()->getcategories());
        $html .= $this->filter('charts.currency',$filtercurrency);
        $html .= $this->filter('charts.pattern', ['ymd'=>'PPF_YMD', 'yW'=>'PPF_YW', 'ym'=>'PPF_YM', 'y'=>'PPF_Y']);
        $html .= $this->filter('charts.published', [''=>'PPF_STATE', 1=>'PPF_PUBLISHED', 0=>'PPF_UNPUBLISHED']);
        $html .= $this->filter('charts.fm',getfm());
        $html .= $this->filter('charts.ps', getps());
        $html .= '</div>';
        echo $html;
    }
}
