<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class viewHtml extends baseView
{
    protected $items;

    public function __construct()
    {
        parent::__construct('freecharts');
        $this->display();
    }

    public function display()
    {
        $this->addFilters();
        $this->items = $this->getItems();

        parent::display();
    }

    protected function addFilters()
    {
        $ses = ppf_session::get('ppf3');
        $filterlist = ppf::get('filterlist', $ses, []);
        
        $pattern = ppf::get('freecharts.pattern', $filterlist);
        if(! $pattern) $_SESSION['ppf3']['filterlist']['freecharts.pattern'] = 'ym';
        
        $end = ppf::get('freecharts.end', $filterlist);
        if(! $end) $_SESSION['ppf3']['filterlist']['freecharts.end'] = date('Y-m-d');
        
        $start = ppf::get('freecharts.start', $filterlist);
        if(! $start || $start[0] != '2') $_SESSION['ppf3']['filterlist']['freecharts.start'] = date('Y-m-d', strtotime("-1 year"));

        $html = '<div class="ppf3_filters">';
        $html .= $this->filtertext('freecharts.start');
        $html .= $this->filtertext('freecharts.end');
        $html .= $this->filter('freecharts.pattern', ['ymd'=>'PPF_YMD', 'yW'=>'PPF_YW', 'ym'=>'PPF_YM', 'y'=>'PPF_Y']);
        $html .= '</div>';
        echo $html;
    }
}
