<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class viewHtml extends baseView
{
    protected $items;

    public function __construct()
    {
      if(ppf::gettask() == 'project.add') {
        parent::__construct('newproject');
        $this->settitle('PPF-3. PPF_PROJECT_CHOICE');
        parent::display();
      }
      else {
        parent::__construct('project');
        $this->display();
      }
    }

    public function display()
    {
      $this->items = $this->getItems();
      if($this->items) {
        $fm = ppf::get('p][fm', $this->items);
      }
      else {
        $fm = ppf::gettask('fm');
      }
      
      if(! $fm) {
        $this->setmessages('The function module is not linked to the entry.', 'err');
        $this->redirect('projects');
      } 
      
      $path = PPF3_ADMIN_DIR . 'src/fm/' . $fm . '/' . $fm.'.xml';

      if(! is_file($path)) {
        $this->setmessages('The function module '.$fm.' not exist.', 'err');
        $this->redirect('projects');
      }
      
      $this->form = $this->getForm($path);
      $this->addToolbar();

      parent::display();
    }

    protected function addToolbar()
    {
        $id = ppf::get('id', $this->items);
        if($id) $this->settitle('PPF-3. PPF_EDIT_PROGECT');
        else  $this->settitle('PPF-3. PPF_ADD_PROGECT');

        $html = '<div class="ppf3_toolbar">';
        $html .= $this->toolbarBtn('project.save', 'Save', ' green');
        $html .= $this->toolbarBtn('project.saveclose', 'PPF_SAVE_CLOSE', ' green');
        $html .= $this->toolbarBtn('project.savecreate', 'PPF_SAVE_CREATE', ' green');
        $html .= $this->toolbarBtn('projects.close', 'Close', ' red');
        $html .= '</div>';
        echo $html;
    }

}
