<?php
/**
* @Copyright ((c) plasma-web.ru
		* @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class viewHtml extends baseView
{
	protected $items;

    public function __construct()
    {
        parent::__construct('projects');
        $this->display();
    }

    public function display()
    {
				if(! isset($_SESSION['ppf3']['filterlist']['projects.limit'])) $_SESSION['ppf3']['filterlist']['projects.limit'] = 24;
				
				$this->items = $this->getItems();
        $this->pagination = $this->getPagination();

        $this->addToolbar();
        $this->addFilters();

        parent::display();
    }

    protected function addToolbar()
    {
		$this->settitle('PPF-3. PPF_PROGECTS_LIST');

        $html = '<div class="ppf3_toolbar">';
				
        $html .= $this->toolbarBtn('project.add', 'PPF_ADD_NEW', ' green');
        $html .= $this->toolbarBtn('projects.activate', 'PPF_ACTIVATE', ' gray');
        $html .= $this->toolbarBtn('projects.deactivate', 'PPF_DEACTIVATE', ' gray');
        $html .= $this->toolbarBtn('project.delete', 'Delete', ' red');
        $html .= $this->toolbarBtn('projects.help', 'Help', '');
				
        $html .= '</div>';
        echo $html;
    }

    protected function addFilters()
    {
        $html = '<div class="ppf3_filters">';
        $html .= $this->filtersearch('projects.search');
				$html .= $this->filter('projects.categories', array(''=>'PPF_CATEGORY')+ppf::categories()->getcategories());
        $html .= $this->filter('projects.published', [''=>'PPF_STATE', 1=>'PPF_PUBLISHED', 0=>'PPF_UNPUBLISHED']);
        $html .= $this->filter('projects.language', $this->getLanguages());
        $html .= $this->filter('projects.access', ppf::getacs());
        $html .= $this->filter('projects.limit', [''=>'12', 24=>'24', 48=>'48', 100=>'100']);

        $html .= '</div>';
        echo $html;
    }

}
