<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class viewHtml extends baseView
{
    protected $items;

    public function __construct()
    {
        parent::__construct('sales');
        $this->display();
    }

    public function display()
    {
        $this->items = $this->getItems();
        $this->pagination = $this->getPagination();

        $this->addToolbar();
        $this->addFilters();

        parent::display();
    }

    protected function addToolbar()
    {
        $this->settitle('PPF-3. PPF_EMAIL_HISTORY');

        $html = '<div class="ppf3_toolbar">';
        $html .= $this->toolbarBtn('sale.add', 'PPF_ADD_NEW', ' green');
        $html .= $this->toolbarBtn('sale.activate', 'PPF_ACTIVATE', ' gray');
        $html .= $this->toolbarBtn('sale.deactivate', 'PPF_DEACTIVATE', ' gray');
        $html .= $this->toolbarBtn('sale.delete', 'Delete', ' red');
        $html .= $this->toolbarBtn('sales.help', 'Help', '');
        $html .= '</div>';
        echo $html;
    }

    protected function addFilters()
    {
      function getfm(){
        $path = PPF3_ADMIN_DIR . 'src/fm';
        $scans = scandir($path);
        $fm[''] = 'fm';
        foreach($scans as $scan) {
          if($scan !='.' && $scan !='..' && is_dir($path.'/'.$scan)) {
            $xml = simplexml_load_file($path.'/'.$scan.'/'.$scan.'.xml');
            $fm[$scan] = Text::_((string)$xml->name);
          }
        }
        return $fm;
      }
      
      function getps() {
        $db = \JFactory::getDbo();
        $arr[''] = 'ps';
        $db->setQuery( 'SELECT id, title FROM #__ppf3_ps');
        $data = $db->loadObjectList();
        foreach($data as $dat) {
          $arr[$dat->id] = $dat->title;
        }
        return $arr;
      }

        $html = '<div class="ppf3_filters">';
        $html .= $this->filtersearch('sales.search');
        $html .= $this->filter('sales.published', [''=>'PPF_STATE', 1=>'PPF_PUBLISHED', 0=>'PPF_UNPUBLISHED']);
        $html .= $this->filter('charts.fm',getfm());
        $html .= $this->filter('charts.ps', getps());
        $html .= $this->filter('sales.limit', [''=>'12', 24=>'24', 48=>'48']);
        $html .= '</div>';
        echo $html;
    }
}
