<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;
$this->addScript('css', 'chart.css');

$curr = explode(',', ppf::config()->currency);
$current_curr = ppf::get('cur', $_GET, trim($curr[0]));

foreach($curr as $cur){
  $cur = trim($cur);
  if($cur == $current_curr) $currency[] = $cur;
  else $currency[] = '<a href="index.php?option=com_ppf3&view=charts&cur='.$cur.'">'.$cur.'</a>';
}
$currency = implode(' ', $currency);
?>
<form method="post" name="ppfadminform" class="formstyle"></form>
<div class="listbox"><a href="index.php?option=com_ppf3&view=sales">List</a> / Chart -> <?php echo $currency ?></div>
<?php
if(empty($this->items)) {
  echo 'not data';
  return;
}

$ses = ppf_session::get('ppf3');
$filterlist = ppf::get('filterlist', $ses, []);

$pattern = ppf::get('charts.pattern', $filterlist, 'ym');

$start = strtotime(ppf::get('charts.start', $filterlist));
$end = strtotime(ppf::get('charts.end', $filterlist));

if($pattern == 'ymd') {
  $add = 24*60*60;
  $ret = 'd M Y';
}
elseif($pattern == 'yW') {
  $add = 7*24*60*60;
  $ret = 'M Y';
}
elseif($pattern == 'ym') {
  $add = 28*24*60*60;
  $ret = 'M Y';
}
elseif($pattern == 'y') {
  $add = 364*24*60*60;
  $ret = 'Y';
}

foreach ($this->items as $item) {
  $d = date($pattern, $item->date);
  if(! isset($arr[$d])) $arr[$d] = 0;
  $arr[$d] += ppf::price()->getPrice($item->price, $item->currency, $current_curr);
}

for ($i = $start; $i <= $end; $i += $add) {
  $d = date($pattern, $i);
  if(! isset($arr[$d])) $arr[$d] = 0;
}

ksort($arr);

$len=count($arr);
$max = max($arr);

if($pattern == 'y') {
  foreach($arr as $k=>$v){
      $abscissa[] = date('Y',strtotime('20'.substr($k,0,2).'-01-01'));
  }
}
elseif($pattern == 'ym' && $len < 13){
  foreach($arr as $k=>$v){
      $abscissa[] = date('M y',strtotime('20'.substr($k,0,2).'-'.substr($k,2,2).'-01'));
  }
}
else {
  $cells = $len<12?$len:12;
  $del = ($end - $start)/$cells;
  if(! $del) $del = 1;
  for($i = $start; $i <= $end; $i += $del) {
    $abscissa[] = date('d M Y', $i);
  }
}

for($i=0; $i < 11; $i++){
  $ordinate[] = round($max-$max*$i/10);
}
$hr = '';
for($i=0; $i<10; $i++){
  $hr .= '<hr style="top:'.($i*40).'px">';
}

$body = '';
foreach($arr as $k=>$v) {
  if($pattern == 'yW') $d = '20'.substr($k,0,2).' ('.substr($k,2).')';
  else{
    $d = \DateTime::createFromFormat($pattern, $k);
    $d = $d->format($ret);
  }
  $body .= '<div style="height:'.round($v/($max/400)).'px" title="'. $v .' ('. $d .')"></div>';
  $hei[] = 400-round($v/($max/400));
}

$ordinate = '<div>'.implode('</div><div>', $ordinate).'</div>';
$abscissa = '<div>'.implode('</div><div>', $abscissa).'</div>';

$svg = '<svg height="400" viewBox="0 0 '.(10*$len).' 400" preserveAspectRatio="none"><polyline points="';

for($i =0; $i < $len; $i++) {
  $d = 0;
  if($len<20){
    if($i && $i < $len-1) $d=($hei[($i-1)]+$hei[($i)]+$hei[($i+1)])/3;
  }
  elseif($len<40){
    if(1 < $i && $i < $len-2) $d=($hei[$i-2]+$hei[$i-1]+$hei[$i]+$hei[$i+1]+$hei[$i+2])/5;
  }
  else {
    if(2 < $i && $i < $len-3) $d=($hei[$i-3] + $hei[$i-2] + $hei[$i-1] + $hei[$i] + $hei[$i+1] + $hei[$i+2] + $hei[$i+3])/7;
  }
  if($d) $svg .= (10*$i+5) . ',' . round($d) . ' ';
}
$svg .= '" style="fill:none;stroke:red;stroke-width:1" /></svg>';
?>
<div id="chart">
  <div id="chart_l"><?php echo $ordinate ?></div>
  <div id="chart_r">
    <div id="chartbody"><?php echo $body ?><?php echo $svg.$hr ?></div>
    <div id="chart_b"><?php echo $abscissa ?></div>
  </div>
</div>

