<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;
?>

<form method="post" name="ppfadminform" class="formstyle">

<table class="ppftable">
    <thead>
        <tr>
            <th><input autocomplete="off" type="checkbox" name="cid[]" onclick="ppfadmin.checkAll(this)"></th>
            <th><?php echo $this->filterdir('published', 'PPF_STATE_2') ?></th>
            <th class="ppftitle"><?php echo $this->filterdir('title', 'Title') ?></th>
            <th><?php echo $this->filterdir('category', 'PPF_CATEGORY') ?></th>
            <th><?php echo $this->filterdir('price', 'PPF_PRICE') ?></th>
            <th><?php echo $this->filterdir('currency', 'PPF_CURRENCY_2') ?></th>
            <th><?php echo $this->filterdir('hits', 'PPF_HITS') ?></th>
            <th><?php echo $this->filterdir('access', 'PPF_ACCESS') ?></th>
            <th><?php echo $this->filterdir('language', 'PPF_LANGUAGE') ?></th>
            <th><?php echo $this->filterdir('rating', 'PPF_RATING') ?></th>
            <th>FM</th>
            <th><?php echo $this->filterdir('id', 'ID') ?></th>
        </tr>
    </thead>
    <tbody>
    <?php
    foreach ($this->items as $item) {
      $mes = [];
      $params = json_decode($item->params);
      if(isset($params->ppffile)) {
        $path = ppf::getfolder($item->id) . $params->ppffile;
        if(is_file($path)) {
          $mes[] = '<span style="color:green">'.$params->ppffile.'</span>';
        }
        else $mes[] = '<span style="color:red">'.Text::_('PPF_NOT_FILE').'</span>';
      }
      if(isset($params->psbtns) && ! ppf::get('psbtns', $params)) {
        $mes[] = '<span style="color:red">'.Text::_('PPF_NOT_BTNS').'</span>';
      }
      $mes = implode(', ',$mes);
        ?>
        <tr>
            <td>
                <input autocomplete="off" type="checkbox" name="cid[]" value="<?php echo $item->id ?>">
            </td>
            <td>
                <?php echo $this->publishbtn('projects',$item) ?>
            </td>
            <td class="ppftitle">
                <a href="index.php?option=com_ppf3&view=projects&task=project.edit&id=<?php echo $item->id ?>"><?php echo $item->title ?></a><div class="fsz68"><span>{PPF3=<?php echo $item->id ?>}</span> 
                  <?php
                  if($params->fm == 'fm_free') {
                    echo '(<a href="index.php?option=com_ppf3&view=freecharts&id=' . $item->id . '">' . Text::_('PPF_SALES2') . '</a>) ' . $mes . '</div>';
                  }
                  else {
                    echo '(<a href="index.php?option=com_ppf3&task=charts.chartid&id='.$item->id.'">'.Text::_('PPF_SALES').'</a>) '.$mes. '</div>';
                  }
                  ?>
            </td>
            <td>
    					<?php if($item->categories) echo $item->categories; ?>
    				</td>
            <td>
                <?php if($item->price) echo $item->price ?>
            </td>
            <td>
                <?php if($item->currency) echo $item->currency ?>
            </td>
            <td>
                <?php if($item->hits) echo $item->hits ?>
            </td>
            <td>
                <?php if($item->access) echo ppf::getacs()[$item->access] ?>
            </td>
            <td>
                <?php if($item->language) echo $item->language ?>
            </td>
            <td>
              <?php if($item->rating) echo $item->rating ?>
            </td>
            <td>
                <?php echo str_replace('fm_', '', $params->fm) ?>
            </td>
            <td>
                <?php echo $item->id ?>
            </td>
        </tr>
        <?php
    }
     ?>
 </tbody>
</table>
<?php echo $this->pagination ?>
</form>
