<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GNU/GPL
        */

defined('_JEXEC') or die();

class com_ppf3InstallerScript
{
    public function install($parent) {
        $this->ppfinstall($parent);
    }

    public function update($parent) {
        $this->ppfinstall($parent);
    }

    public function ppfinstall($parent) {
        $db = JFactory::getDBO();
        $manifest = $parent->getParent()->manifest;
        $src = $parent->getParent()->getPath('source');

        $plugins = $manifest->xpath('plugins/plugin');
        foreach ($plugins as $plugin) {
            $installer = new JInstaller;
            $installer->install($src.'/plugins/'.(string)$plugin->attributes()->plugin);
            $query = "UPDATE #__extensions SET enabled=1 WHERE type='plugin' AND element=".$db->Quote((string)$plugin->attributes()->plugin)." AND folder=".$db->Quote((string)$plugin->attributes()->group);
            $db->setQuery($query);
            $db->execute();
        }

        $modules = $manifest->xpath('modules/module');
        foreach ($modules as $module) {
            $installer = new JInstaller;
            $installer->install($src.'/modules/'.(string)$module->attributes()->module);
        }

        return ;
    }

    public function uninstall($parent) {
        $db = JFactory::getDBO();
        $manifest = $parent->getParent()->manifest;

        $plugins = $manifest->xpath('plugins/plugin');
        foreach ($plugins as $plugin) {
            $query = "SELECT `extension_id` FROM #__extensions WHERE `type`='plugin' AND element = ".$db->Quote((string)$plugin->attributes()->plugin)." AND folder = ".$db->Quote((string)$plugin->attributes()->group);
            $db->setQuery($query);
            $extensions = $db->loadColumn();
            if (count($extensions)) {
                foreach ($extensions as $id) {
                    $installer = new JInstaller;
                    $installer->uninstall('plugin', $id);
                }
            }

        }
        $modules = $manifest->xpath('modules/module');
        foreach ($modules as $module) {
            $query = "SELECT `extension_id` FROM `#__extensions` WHERE `type`='module' AND element = ".$db->Quote((string)$module->attributes()->module)."";
            $db->setQuery($query);
            $extensions = $db->loadColumn();
            if (count($extensions)) {
                foreach ($extensions as $id) {
                    $installer = new JInstaller;
                    $installer->uninstall('module', $id);
                }
            }
        }
    }

}
