<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class btns
{
  public function getBtns($id) {
    
    if (isset($_GET['ppf3success'])) {
      $url = "//$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
      $url = str_replace(['?ppf3success=1','&ppf3success=1'], '', $url);
      $app = \JFactory::getApplication();
      $app->enqueueMessage(Text::_('PPF_SUC'), 'message');
      $app->redirect($url);
    }

    ppf::addScript ('js', 'js/ppf3.js');
    Text::input (ppf::config()->text, 'ppf' .$_SERVER['HTTP_HOST']);

    $fm = $this->getFm($id);
    if(! $fm) return '';
    
    setcookie("ppftest", 'ppf3', time()+3600, '/');
    
    $fm_params = json_decode($fm->params);
    $accept = $this->getAccess($fm);
    $pss = false;
  
    if(! $accept) {
      $pss = $this->getpss($fm);
    }

    if(ppf::get('tmpl', $fm_params)) {
      $tmpl = PPF3_PLUGIN_DIR.'templates/buttons/'.$fm_params->tmpl.'/'.$fm_params->tmpl.'.php';
      if(file_exists($tmpl))
      {
        require_once($tmpl);
        $classname = 'PPF3\\tmpl_' . $fm_params->tmpl;
        $template = new $classname();
        
        if($accept) return $template->paid($fm);
        else return $template->unpaid($fm, $pss);
      }
      else return '<h3>PPF-3: (Id:'.$fm->id.') => no template selected.</h3>';
    }
    elseif($actual = ppf::getFmClass($fm)) {
      if($accept) return $actual->paid($fm);
      else return $actual->unpaid($fm, $pss);
    }
  }
  
  public function getpss($fm) {
    $db = \JFactory::getDbo();
    $user = \JFactory::getUser();
    $groups = $user->getAuthorisedViewLevels();
    $fm_params = json_decode($fm->params);
    
    if(! isset($fm_params->psbtns) || ! $fm_params->psbtns) return '<h3>PPF-3: (id:'.$fm->id.') => payment buttons are not assigned.</h3>';
    
    $db->setQuery('SELECT * FROM #__ppf3_ps  WHERE published = 1 AND id IN ( ' . implode(',', $fm_params->psbtns) . ') AND (language = \''. ppf::getlang() .'\' OR language = \'\') AND (access IN (' . implode(',', $groups) . ') OR access = 0)');
    
    return $db->loadObjectList();
  }
  
  public function psform() {
    $db = \JFactory::getDbo();
    $user = \JFactory::getUser();
    $groups = implode(',', $user->getAuthorisedViewLevels());
    $post = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
    $db->setQuery('
      SELECT a.ps, a.params as psparams, b.* 
      FROM #__ppf3_ps a, #__ppf3_projects b 
      WHERE a.published = 1 
      AND b.published = 1 
      AND a.id = '.(int) ppf::get('ps', $post).' 
      AND (a.language = \''. ppf::getlang() .'\' OR a.language = \'\') 
      AND (a.access IN ('. $groups .') OR a.access = 0)
      AND b.id = '.(int) ppf::get('fm', $post).' 
      AND (b.language = \''. ppf::getlang() .'\' OR b.language = \'\') 
      AND (b.access IN ('. $groups .') OR b.access = 0)
    ');
    $item = $db->loadObject();
    
    if(! $item) return '';
    
    $fm_params = json_decode($item->params);
    
    $accessinterface = ppf::get('accessinterface', $fm_params);
    $elongated = ppf::get('elongated', $fm_params);
    
    $ses_id = '';
    if ($elongated) $ses_id = md5(session_id());

    if($accessinterface != 1) {
      if (! isset($_COOKIE['ppftest']) || $_COOKIE['ppftest'] != 'ppf3') {
        return 'Enable cookies, please.';
      }
    }
    
    $enddate = time() + 60 * ppf::num(ppf::get('lifetime', $fm_params));
    
    $params = json_encode($post['p'], JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
    
    $inputData = array(
        'id' 	=> 0,
        'ps'   => (int) $post['ps'],
        'fm'   => (int) $post['fm'],
        'user'   => (int) $user->get('id'),
        'date'   => (int) time(),
        'enddate'   => (int) $enddate,
        'ses_id'   => '\''. $ses_id .'\'',
        'params'   => '\''. addslashes($params) .'\'',
     );
     $db->setQuery("INSERT INTO #__ppf3_temp (".implode(',', array_keys($inputData)).") VALUES (".implode(',', array_values($inputData)).")");
     $db->execute();
     $id = $db->insertid();

     $db->setQuery("DELETE FROM #__ppf3_temp WHERE enddate < " . (int) time());
     $db->execute();
     
    if($id)
    {
      if($accessinterface != 1) {
        $this->ppf_setCookie($id, $item);
      }

      $path = PPF3_ADMIN_DIR.'src/ps/'.$item->ps.'/'.$item->ps.'.php';
      if(file_exists($path))	{
         require_once($path);
         $classname = 'PPF3\\' . $item->ps;
         $form = new $classname();
         return $form->getPsForm($id, $item, $post);
      }
    }
  }
  
  public function getFm($id) {
    if(((int) ppf::gl('lang') - time()) < 0) return '';
    $db = \JFactory::getDbo();
    $groups = \JFactory::getUser()->getAuthorisedViewLevels();
    $db->setQuery('
      SELECT * FROM #__ppf3_projects a WHERE id = '. (int) $id .'
          AND published = 1
          AND (language = \''. ppf::getlang() .'\' OR language = \'\')
          AND (access IN ('. implode(',', $groups) .') OR access = 0)
    ');
    return $db->loadObject();
  }
  
  
  public function getAccess($fm) {
    $db = \JFactory::getDbo();
    $user = \JFactory::getUser();
    $groups = $user->getAuthorisedViewLevels();
    $userid = $user->get('id');
    $res = false;

    $fm_params = json_decode($fm->params);

    $freeaccess = ppf::get('freeaccess', $fm_params);
    if(in_array($freeaccess, $groups)) {
      return 1;
    }
    else {
      $accessinterface = ppf::get('accessinterface', $fm_params);
      $elongated = ppf::get('elongated', $fm_params);
      
      if($accessinterface == 1 && ! $userid) return false;
      elseif($accessinterface == 1) {
        $db->setQuery('SELECT * FROM #__ppf3_history  WHERE published = 1 AND projectid = '. (int) $fm->id .' AND user = '. (int) $userid);
        $res = $db->loadObject();
        if($res) {
          ppf::gl('history', $res);
          return true;
        }
      }
      elseif($accessinterface == 2) {
        if ($userid) {
          $db->setQuery('SELECT * FROM #__ppf3_history  WHERE published = 1 AND projectid = '. (int) $fm->id .' AND user = '. (int) $userid);
          $res = $db->loadObject();
          if($res) {
            ppf::gl('history', $res);
            return true;
          }
        }
        
        if ($elongated) {
          $db->setQuery('SELECT * FROM #__ppf3_history  WHERE published = 1 AND projectid = '. (int) $fm->id .' AND ses_id = \''. md5(session_id()) .'\'');
          $res = $db->loadObject();
        }
        
        if (! $res) {
          $res = $this->getAccessFromCookie($fm);
        }
      }
      elseif (! $accessinterface) {
        if ($elongated) {
          $db->setQuery('SELECT * FROM #__ppf3_history  WHERE published = 1 AND projectid = '. (int) $fm->id .' AND ses_id = \''. md5(session_id()) .'\'');
          $res = $db->loadObject();
        }
        
        if (! $res) {
          $res = $this->getAccessFromCookie($fm);
        }
      }
      
      if ($res) {
        ppf::gl('history', $res);
        if (in_array(ppf::gettask(), ['download', 'video'])) return 1;
        
        if (! isset($_GET['noCache'])) {
          $url = "//$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
          $url .= (! strpos($url, '?') ? '?' : '&') . 'noCache='.rand();
          header('Location: ' . $url);
          exit;
        }
        
        return true;
      }
      
      return false;
    }
  }
  
  
  public function getAccessFromCookie($fm) {
    if (! isset($_COOKIE['ppf3'])) return false;
    $str = Text::input($_COOKIE['ppf3']);
    $ids = explode(',', $str);
    foreach ($ids as &$id) $id = (int) $id;
    $str = implode(',', $ids);
    $db = \JFactory::getDbo();
    $db->setQuery('SELECT * FROM #__ppf3_history  WHERE published = 1 AND temp_id IN('.$str.') AND projectid = ' . (int) $fm->id . ' AND enddate > ' . (int) time());
    $obj = $db->loadObject();
    if ($obj) {
      $fm_params = json_decode($fm->params);
      $elongated = ppf::get('elongated', $fm_params);
      $currses = md5(session_id());
      if ($elongated && $currses != $obj->ses_id) {
        $db = \JFactory::getDbo();
        $db->setQuery('UPDATE #__ppf3_history SET ses_id = \''. $currses .'\' WHERE id = '.(int) $obj->id);
        $db->execute();
      }
      return $obj;
    }
    return false;
  }
  
  
  public function ppf_setCookie($id, $item) {
    // Идентификаторы формируемые таблицей __ppf3_temp через запятую (как оплаченные, так и ожидающие оплаты). Так как идентификаторы уникальны, не может быть другого пользователя с такими же. Шифруем cookie секретным ключём.
    $fm_params = json_decode($item->params);
    $enddate = time() + 60 * ppf::num(ppf::get('lifetime', $fm_params));
    
    if (! isset($_COOKIE['ppf3'])) {
      $str = $this->encode($id);
      setcookie('ppf3', $str, $enddate, '/');
    }
    else {
      $db = \JFactory::getDbo();
      $str = Text::input($_COOKIE['ppf3']);
      $ids = explode(',',$str);
      $new = array();
      
      foreach ($ids as $i) {
        if((int)$i == $i) {
          $db->setQuery('SELECT enddate FROM #__ppf3_history  WHERE published = 1 AND temp_id = '. (int) $i);
          $res = $db->loadResult();
          if(! $res) {
            $db->setQuery('SELECT enddate FROM #__ppf3_temp  WHERE id = '. (int) $i);
            $res = $db->loadResult();
          }
          
          if($res && $res > time()) {
            $new[] = $i;
            if($res > $enddate) $enddate = $res;
          }
        }
      }
      
      $new[] = $id;
      
      $newstr = $this->encode(implode(',', $new));
      setcookie('ppf3', $newstr, $enddate, '/');
    }
  }

  public function encode ($plaintext) {
    $ivlen = openssl_cipher_iv_length($cipher="AES-128-CBC");
    $iv = openssl_random_pseudo_bytes($ivlen);
    $ivc = ppf::config()->secret;
    $ciphertext_raw = openssl_encrypt($plaintext, $cipher, $ivc, $options=OPENSSL_RAW_DATA, $iv);
    $hmac = hash_hmac('sha256', $ciphertext_raw, $ivc, $as_binary=true);
    $ciphertext = base64_encode( $iv.$hmac.$ciphertext_raw );
    return $ciphertext;
  }
  
  public function getTemp ($index) {
    $db = \JFactory::getDbo();
    $db->setQuery(
      'SELECT * 
      FROM #__ppf3_temp 
      WHERE id = '. (int) $index
    );
    return $db->loadObject();
  }
  
  public function getItemForHistory ($temp) {
    $db = \JFactory::getDbo();
    $db->setQuery('
      SELECT a.params as psparams, b.* 
      FROM #__ppf3_ps a, #__ppf3_projects b 
      WHERE a.published = 1 
      AND b.published = 1 
      AND a.id = '.(int) $temp->ps.' 
      AND b.id = '.(int) $temp->fm.' 
    ');
    return $db->loadObject();
  }

  public function insertHistory ($post, $temp, $item, $realprice) {
    $db = \JFactory::getDbo();
    $reqparams = json_encode($post, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
    
    $fm_params = json_decode($item->params);
    $ps_params = json_decode($item->psparams);
    
    $temp_params = json_decode($temp->params);
    unset($temp_params->url);
    $temp_params = json_encode($temp_params, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
    
    $enddate = ppf::num(ppf::get('lifetime', $fm_params));
    $enddate = $enddate ? time() + 60 * $enddate : 0;
    
    $inputData = array(
        'id' 	=> 0,
        'published'   => 1,
        'date'   => (int) time(),
        'enddate'   => (int) $enddate,
        'projectid'   => (int) $temp->fm,
        'price'   => (float) $realprice,
        'currency'   => '\''.addslashes($ps_params->currency).'\'',
        'user'   => (int) $temp->user,
        'ps'   => (int) $temp->ps,
        'fm'   => '\''.addslashes($fm_params->fm).'\'',
        'temp_id'   => (int) $temp->id,
        'ses_id'   => '\''.addslashes($temp->ses_id).'\'',
        'params'   => '\''.addslashes($temp_params).'\'',
        'reqparams'   => '\''.addslashes($reqparams).'\''
     );
     $db->setQuery("INSERT INTO #__ppf3_history (".implode(',', array_keys($inputData)).") VALUES (".implode(',', array_values($inputData)).")");

     if($db->execute()) {
       $item->historyid = $db->insertid();
       $item->enddate = $enddate;

       if($actual = ppf::getFmClass($item)) {
         return $actual->afterPay($item, $temp, $realprice);
       }
       return true;
     }
     return false;
  }

}
