<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class categories
{
  public function getItemsFromCategory ($cid, $filter = true) {
    $tree = $this->categoriesTree($cid, true, true);
    if (! $tree) return '';
    
    $parent = $tree[0];
    $parent_params = json_decode($parent->params);
    if (! $parent_params->qty) return '';

    $catIds = $this->getallchildid($tree);
    if(! $catIds) return '';

    foreach ($catIds as $catid) {
      $or[] = 'categories REGEXP ".*(^|,)'.(int) $catid.'($|,).*"';
    }
    
    $where[] = '('.implode(' OR ', $or).')';
    
    if($filter) {
      $user = \JFactory::getUser();
      $groups = $user->getAuthorisedViewLevels();
      $where[] = 'published = 1';
      $where[] = '(language = \''. ppf::getlang() .'\' OR language = \'\')';
      $where[] = '(access IN (' . implode(',', $groups) . ') OR access = 0)';
    }
    
    $where = implode(' AND ', $where);

    $db = \JFactory::getDbo();
    $db->setQuery("SELECT * FROM #__ppf3_projects WHERE $where ORDER BY rating desc LIMIT 0, " . (int) $parent_params->qty);
    $items = $db->loadObjectList();
    
    if(ppf::get('tmpl', $parent_params)) {
      $tmpl = PPF3_PLUGIN_DIR.'templates/categories/'.$parent_params->tmpl.'/'.$parent_params->tmpl.'.php';
      if(file_exists($tmpl))
      {
        require_once($tmpl);
        $classname = 'PPF3\\cat_tmpl_' . $parent_params->tmpl;
        $template = new $classname();
        return $template->list($items);
      }
      else return '<h3>PPF-3: (catId:'.$parent->id.') => no category template selected.</h3>';
    }
    else {
      $html = '';
      foreach ($items as $item) {
        $html .= ppf::btns()->getBtns($item->id);
      }
      return $html;
    }
  }
  
  public function getallchildid($tree) {
    $arr=[];
    foreach($tree as $cat) {
      $arr[] = (int) $cat->id;
      if($cat->child) $arr = array_merge($arr,$this->getallchildid($cat->child));
    }
    return array_unique($arr);
  }
  
  public function categoriesTree($id=0, $filter = false, $parent = false) {
    if($filter) {
      $user = \JFactory::getUser();
      $groups = $user->getAuthorisedViewLevels();
      $where[] = 'published = 1';
      $where[] = '(language = \''. ppf::getlang() .'\' OR language = \'\')';
      $where[] = '(access IN (' . implode(',', $groups) . ') OR access = 0)';
    }
    
    if ($parent) $where[] = 'id = '. (int) $id;
    else $where[] = 'parent = '. (int) $id;
    
    $where = implode(' AND ', $where);
    
    $db = \JFactory::getDbo();
    $db->setQuery("SELECT * FROM #__ppf3_categories WHERE $where ORDER BY rating desc");
    $data = $db->loadObjectList();
    foreach($data as &$dat) {
      $dat->child = $this->categoriesTree($dat->id, $filter);
    }
    return $data;
  }
  
  public function catlist($tree, $i = 0) {
    $i++; $d = ''; $opt=[];
    for($ii=$i; $ii>0; $ii--) $d .= ' — ';
    foreach($tree as $cat) {
      $opt[$cat->id] = $d.$cat->title;
      if($cat->child) $opt += $this->catlist($cat->child, $i);
    }
    return $opt;
  }
  
  public function getcategories() {
    return $this->catlist($this->categoriesTree());
  }

}