<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class ppfCurrency
{
	var $_filecontent = null;
	var $_rates = null;
	
	protected function getXml() {
		if($this->_filecontent) return $this->_filecontent;
    
		$url = 'http://www.cbr.ru/scripts/XML_daily.asp';
		$path = PPF3_PLUGIN_DIR.'/assets/cbr.xml';
		$date_now_local = gmdate('Ymd');
		
		if(file_exists($path))
    {
			$file_datestamp = date('Ymd', filemtime($path)); 
			if($date_now_local > $file_datestamp)
			{
				
				$oldhistory = time() - 24*3600;
				$db = \JFactory::getDbo();
				$db->setQuery("UPDATE #__ppf3_history SET ses_id = '' WHERE ses_id != '' AND enddate < " . (int) $oldhistory);
				$db->execute();

				if($content = @file_get_contents($url)) {
					file_put_contents($path, $content);
				} else {
					$content = file_get_contents($path);
				}
			} else {
				$content = file_get_contents($path);
			}
		}
		else {
			$content = @file_get_contents($url);
			file_put_contents($path, $content );
		}
		$this->_filecontent=$content;
		return $content;
	}
	
	protected function getCurrencyRates() {
		if(! $this->_rates) {
			$xml = simplexml_load_string($this->getXml());
			$arr["RUB"] = 1;
			foreach ($xml as $el){
          $arr[strval($el->CharCode)] = $el->Nominal/$el->Value;
			}
			$this->_rates = $arr;
		}
		return $this->_rates;
	}
	
	public function getPrice($price, $from, $to, $dec=0) {
    if($to == $from) return $price;
		$rates = $this->getCurrencyRates();
    return round($price/$rates[$from]*$rates[$to], $dec);
	}
	
	public function full($fm, $ps_params, $format = false) {
		$actual = ppf::getFmClass($fm);
		$price = $actual->getPriceValue($fm) * $ps_params->ps_multiplier;
		$fm_params = json_decode($fm->params);
		$price = $this->getPrice($price, $fm->currency, $ps_params->currency, $fm_params->round);
		if($format) return number_format($price, $fm_params->round, ',', ' ');
		else return $price;
	}
}
