<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class ppf_email
{
  public function send($item, $temp) {
    $fm_params = json_decode($item->params);
    $ps_params = json_decode($item->psparams);
    $temp_params = json_decode($temp->params);

    $mailfrom = \JFactory::getApplication()->get('mailfrom');
    $fromname = \JFactory::getApplication()->get('fromname');
    
    $subject = ppf::get('emailsubj', $fm_params);
    if(! $subject) {
      $subject = 'id:{replacerId}. Purchase on site {replacerHost}';
    }
    $subject = $this->replace($item, $temp_params, $subject);
    
    $to = filter_var(ppf::get('email', $temp_params), FILTER_VALIDATE_EMAIL);
    $message = ppf::get('emailmes', $fm_params);

    if($to && $message) {
      $message = $this->replace($item, $temp_params, $message);
      
      $this->mail_cms($to, $fromname, $mailfrom, $subject, $message, $mailfrom);
    }
    

    if($adminback = ppf::get('adminback', $fm_params)) {
      $adminMessage = 'New site purchase {replacerHost}. Buyer: {replacerName}, Email: {replacerEmail}, Project: '.$item->title.', Sum: '. ppf::price()->full($item, $ps_params).' ' . $ps_params->currency;
      $adminMessage = $this->replace($item, $temp_params, $adminMessage);

      $this->mail_cms($adminback, $fromname, $mailfrom, $subject, $adminMessage, '');
    }
  }
  
  public function mail_cms($to, $fromname, $mailfrom, $subject, $message, $replyto) {
    $mail = \JFactory::getMailer();
    $mail->addRecipient($to);
    $mail->setSender(array($mailfrom, $fromname));
    $mail->setSubject($subject);
    $mail->setBody($message);
    if ($replyto) {
      $mail->addReplyTo($replyto);
    }
    // $mail->isHTML(true);
    return $mail->Send();
  }
  
  public function mail_php($to, $from_user, $from_email, $subject, $message, $replyto) {
      $from_user = "=?UTF-8?B?".base64_encode($from_user)."?=";
      $subject = "=?UTF-8?B?".base64_encode($subject)."?=";

      $headers = "From: $from_user <$from_email>\r\n".
               "MIME-Version: 1.0" . "\r\n" .
               ($replyto ? "Reply-To: $replyto\r\n" : '') .
               "Content-type: text/html; charset=UTF-8" . "\r\n";

     return mail($to, $subject, $message, $headers);
   }
   
   public function replace($item, $temp_params, $text) {
     return str_replace([
           '{replacerId}',
           '{replacerHost}',
           '{replacerName}',
           '{replacerEmail}',
           '{replacerUrl}',
           '{sessionTime}',
           '{endDate}'
        ], [
             $item->historyid,
             $_SERVER['HTTP_HOST'],
             ppf::get('name', $temp_params, 'Guest'),
             ppf::get('email', $temp_params, 'not filled'),
             ppf::get('url', $temp_params, $_SERVER['HTTP_HOST']),
             (ini_get("session.gc_maxlifetime") / 60),
             date("Y-m-d H:i:s", $item->enddate)
     ], $text);
   }

}