<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class tmpl_modal extends btns
{
  public function unpaid($fm, $pss) {
    $fm_params = json_decode($fm->params);
    if(ppf::get('css', $fm_params)) {
      ppf::addScript('css', '//'.$_SERVER['HTTP_HOST'].'/components/com_ppf3/templates/buttons/modal/modal.css');
    }
    $uniq = uniqid();

    $html = '<div class="ppf3_btns '.$fm_params->fm.' tmpl_modal">';
    $html = '<div class="tmpl_modal_close">×</div>';

    if($pss && $toptext = ppf::get('toptext', $fm_params)) {
      $html .= '<div class="ppf3_toptext">'.$toptext.'</div>';
    }

    if($actual = ppf::getFmClass($fm)) {
      $html .= $actual->getpreForm($fm, $uniq);
    }
    

    if($pss) {
      $html .= '<form class="btns_form"><div class="ppf3_modal">';
      
      if($midltext = ppf::get('midltext', $fm_params)) {
        $html .= '<div class="ppf3_midltext">'.$midltext.'</div>';
      }
      
      foreach ($pss as $ps) {
        $ps_params = json_decode($ps->params);
        
        $html .= '<div class="ppf3_block">';
        
          $html .= '<div class="ppf3_currtitle">';
            $html .= ($title = ppf::get('pstext', $ps_params)) ? $title : $ps->title;
          $html .= '</div>';
          
          $html .= '<div class="ppf3_price">';
            if($fm_params->showfield) {
              $html .= '<input type="text" id="sum_'.$ps->id.$uniq.'" value="'.ppf::price()->full($fm, $ps_params).'" required>';
            }
            else {
              $html .= ppf::price()->full($fm, $ps_params, true);
            }
            $html .= '<span class="ppf3_currency">';
              $html .= Text::_($ps_params->currency);
            $html .= '</span>';
          $html .= '</div>';
          
          $html .= '<div class="ppf3_btn">';
            $html .= '<a href="javascript:PPF3.submit(\''.$uniq.'\', '.$ps->id.')">'.($fm_params->btntext?$fm_params->btntext:$ps_params->btntext).'</a>';
          $html .= '</div>';
          
        $html .= '</div>';
        
        
      }
      $html .= '</div></form>';
    }
    
    if($pss && $bottomtext = ppf::get('bottomtext', $fm_params)) {
      $html .= '<div class="ppf3_bottomtext">'.$bottomtext.'</div>';
    }

    $html .= '</div>';
    
    $html = '<script>var ppf3'.$uniq.' = \''.addslashes($html).'\'</script>';
    
    $html .= '<a href="javascript:PPF3.modal(ppf3'.$uniq.')" class="ppf3_modal_link">' . Text::_('PPF_MODAL_PAY') . '</a>';
    
    if(ppf::get('noindex', $fm_params)) return '<noindex>'.Text::translate($html).'</noindex>';
    else return Text::translate($html);
  }
  
  public function paid($fm) {
    $html = '<div class="ppf3_paid">';
    if($actual = ppf::getFmClass($fm)) {
      $html .= $actual->paid($fm);
    } 
    $html .= '</div>';
    return $html;
  }
}