<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace PPF3;

\defined('PPF3_VERSION') or die;

class tmpl_table extends btns
{
  public function unpaid($fm, $pss) {
    $fm_params = json_decode($fm->params);
    if(ppf::get('css', $fm_params)) {
      ppf::addScript('css', '//'.$_SERVER['HTTP_HOST'].'/components/com_ppf3/templates/buttons/table/table.css');
    }
    $uniq = uniqid();

    $html = '<div class="ppf3_btns '.$fm_params->fm.' tmpl_table">';
    
    if($pss && $toptext = ppf::get('toptext', $fm_params)) {
      $html .= '<div class="ppf3_toptext">'.$toptext.'</div>';
    }

    if($actual = ppf::getFmClass($fm)) {
      $html .= $actual->getpreForm($fm, $uniq);
    }
    
    if($pss && $midltext = ppf::get('midltext', $fm_params)) {
      $html .= '<div class="ppf3_midltext">'.$midltext.'</div>';
    }

    if($pss) {
      $html .= '<form><table class="ppf3_table">';
      foreach ($pss as $ps) {
        $ps_params = json_decode($ps->params);
        $html .= '<tr>';
          $html .= '<td class="ppf3_currtitle">';
            $html .= ($title = ppf::get('pstext', $ps_params)) ? $title : $ps->title;
          $html .= '</td>';
          $html .= '<td class="ppf3_price">';
            if($fm_params->showfield) {
              $html .= '<input type="text" id="sum_'.$ps->id.$uniq.'" value="'.ppf::price()->full($fm, $ps_params).'" required>';
            }
            else {
              $html .= ppf::price()->full($fm, $ps_params, true);
            }
          $html .= '</td>';
          $html .= '<td class="ppf3_currency">';
            $html .= Text::_($ps_params->currency);
          $html .= '</td>';
          $html .= '<td class="ppf3_btn">';
            $html .= '<a href="javascript:PPF3.submit(\''.$uniq.'\', '.$ps->id.')">'.($fm_params->btntext?$fm_params->btntext:$ps_params->btntext).'</a>';
          $html .= '</td>';
        $html .= '</tr>';
      }
      $html .= '</table></form>';
    }
    
    if($pss && $bottomtext = ppf::get('bottomtext', $fm_params)) {
      $html .= '<div class="ppf3_bottomtext">'.$bottomtext.'</div>';
    }

    $html .= '</div>';
    
    if(ppf::get('noindex', $fm_params)) return '<noindex>'.Text::translate($html).'</noindex>';
    else return Text::translate($html);
  }
  
  public function paid($fm) {
    $html = '<div class="ppf3_paid">';
    if($actual = ppf::getFmClass($fm)) {
      $html .= $actual->paid($fm);
    } 
    $html .= '</div>';
    return $html;
  }

}


